Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for Announcements
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class AnnouncementController

        ' Preload our schema..
        Dim thisSchemaLoad As Announcement = New Announcement()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As AnnouncementCollection

            Dim coll As AnnouncementCollection = New AnnouncementCollection()
            Dim qry As Query = New Query(Announcement.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Id As Object) As AnnouncementCollection

            Dim coll As AnnouncementCollection = New AnnouncementCollection().Where("id", Id).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As AnnouncementCollection

            Dim coll As AnnouncementCollection = New AnnouncementCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Id As Object) As Boolean

            Return (Announcement.Delete(Id) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Id As Object) As Boolean

            Return (Announcement.Destroy(Id) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal Itemdate As DateTime, ByVal Title As String, ByVal Description As String, ByVal StaticURL As String, ByVal Photo As Integer, ByVal Albumid As Nullable(Of Integer))

            Dim item As Announcement = New Announcement()

            item.Itemdate = Itemdate

            item.Title = Title

            item.Description = Description

            item.StaticURL = StaticURL

            item.Photo = Photo

            item.Albumid = Albumid


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Id As Integer, ByVal Itemdate As DateTime, ByVal Title As String, ByVal Description As String, ByVal StaticURL As String, ByVal Photo As Integer, ByVal Albumid As Nullable(Of Integer))

            Dim item As Announcement = New Announcement()

            item.Id = Id

            item.Itemdate = Itemdate

            item.Title = Title

            item.Description = Description

            item.StaticURL = StaticURL

            item.Photo = Photo

            item.Albumid = Albumid

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
