Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for aspnet_Applications
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class AspnetApplicationController

        ' Preload our schema..
        Dim thisSchemaLoad As AspnetApplication = New AspnetApplication()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As AspnetApplicationCollection

            Dim coll As AspnetApplicationCollection = New AspnetApplicationCollection()
            Dim qry As Query = New Query(AspnetApplication.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal ApplicationId As Object) As AspnetApplicationCollection

            Dim coll As AspnetApplicationCollection = New AspnetApplicationCollection().Where("ApplicationId", ApplicationId).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As AspnetApplicationCollection

            Dim coll As AspnetApplicationCollection = New AspnetApplicationCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal ApplicationId As Object) As Boolean

            Return (AspnetApplication.Delete(ApplicationId) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal ApplicationId As Object) As Boolean

            Return (AspnetApplication.Destroy(ApplicationId) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal ApplicationName As String, ByVal LoweredApplicationName As String, ByVal ApplicationId As Guid, ByVal Description As String)

            Dim item As AspnetApplication = New AspnetApplication()

            item.ApplicationName = ApplicationName

            item.LoweredApplicationName = LoweredApplicationName

            item.ApplicationId = ApplicationId

            item.Description = Description


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal ApplicationName As String, ByVal LoweredApplicationName As String, ByVal ApplicationId As Guid, ByVal Description As String)

            Dim item As AspnetApplication = New AspnetApplication()

            item.ApplicationName = ApplicationName

            item.LoweredApplicationName = LoweredApplicationName

            item.ApplicationId = ApplicationId

            item.Description = Description

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
