Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the AspnetPersonalizationPerUser class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class AspnetPersonalizationPerUserCollection
        Inherits ActiveList(Of AspnetPersonalizationPerUser, AspnetPersonalizationPerUserCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is an ActiveRecord class which wraps the aspnet_PersonalizationPerUser table.
    ''' </summary>
    <Serializable()> _
    Partial Public Class AspnetPersonalizationPerUser
        Inherits ActiveRecord(Of AspnetPersonalizationPerUser)
#Region ".ctors and Default Settings"

        Public Sub New()
            SetSQLProps()
            InitSetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub
        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByKey(keyID)
        End Sub
        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByParam(columnName, columnValue)
        End Sub
        Private Sub InitSetDefaults()
            SetDefaults()
        End Sub

        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region

#Region "Schema and Query Accessor"

        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If BaseSchema Is Nothing Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property
        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("aspnet_PersonalizationPerUser", TableType.Table, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"
                'columns


                Dim colvarId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarId.ColumnName = "Id"
                colvarId.DataType = DbType.Guid
                colvarId.MaxLength = 0
                colvarId.AutoIncrement = False
                colvarId.IsNullable = False
                colvarId.IsPrimaryKey = True
                colvarId.IsForeignKey = False
                colvarId.IsReadOnly = False

                colvarId.DefaultSetting = "(newid())"


                schema.Columns.Add(colvarId)

                Dim colvarPathId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarPathId.ColumnName = "PathId"
                colvarPathId.DataType = DbType.Guid
                colvarPathId.MaxLength = 0
                colvarPathId.AutoIncrement = False
                colvarPathId.IsNullable = True
                colvarPathId.IsPrimaryKey = False
                colvarPathId.IsForeignKey = True
                colvarPathId.IsReadOnly = False


                colvarPathId.ForeignKeyTableName = "aspnet_Paths"

                schema.Columns.Add(colvarPathId)

                Dim colvarUserId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarUserId.ColumnName = "UserId"
                colvarUserId.DataType = DbType.Guid
                colvarUserId.MaxLength = 0
                colvarUserId.AutoIncrement = False
                colvarUserId.IsNullable = True
                colvarUserId.IsPrimaryKey = False
                colvarUserId.IsForeignKey = True
                colvarUserId.IsReadOnly = False


                colvarUserId.ForeignKeyTableName = "aspnet_Users"

                schema.Columns.Add(colvarUserId)

                Dim colvarPageSettings As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarPageSettings.ColumnName = "PageSettings"
                colvarPageSettings.DataType = DbType.Binary
                colvarPageSettings.MaxLength = 2147483647
                colvarPageSettings.AutoIncrement = False
                colvarPageSettings.IsNullable = False
                colvarPageSettings.IsPrimaryKey = False
                colvarPageSettings.IsForeignKey = False
                colvarPageSettings.IsReadOnly = False


                schema.Columns.Add(colvarPageSettings)

                Dim colvarLastUpdatedDate As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarLastUpdatedDate.ColumnName = "LastUpdatedDate"
                colvarLastUpdatedDate.DataType = DbType.DateTime
                colvarLastUpdatedDate.MaxLength = 0
                colvarLastUpdatedDate.AutoIncrement = False
                colvarLastUpdatedDate.IsNullable = False
                colvarLastUpdatedDate.IsPrimaryKey = False
                colvarLastUpdatedDate.IsForeignKey = False
                colvarLastUpdatedDate.IsReadOnly = False


                schema.Columns.Add(colvarLastUpdatedDate)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("aspnet_PersonalizationPerUser", schema)
            End If
        End Sub
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function

#End Region

#Region "Props"


        <XmlAttribute("Id")> _
        Public Property Id() As Guid
            Get
                Return GetColumnValue(Of Guid)("Id")
            End Get

            Set(ByVal value As Guid)
                SetColumnValue("Id", Value)
            End Set
        End Property



        <XmlAttribute("PathId")> _
        Public Property PathId() As Nullable(Of Guid)
            Get
                Return GetColumnValue(Of Nullable(Of Guid))("PathId")
            End Get

            Set(ByVal value As Nullable(Of Guid))
                SetColumnValue("PathId", Value)
            End Set
        End Property



        <XmlAttribute("UserId")> _
        Public Property UserId() As Nullable(Of Guid)
            Get
                Return GetColumnValue(Of Nullable(Of Guid))("UserId")
            End Get

            Set(ByVal value As Nullable(Of Guid))
                SetColumnValue("UserId", Value)
            End Set
        End Property



        <XmlAttribute("PageSettings")> _
        Public Property PageSettings() As Byte()
            Get
                Return GetColumnValue(Of Byte())("PageSettings")
            End Get

            Set(ByVal value As Byte())
                SetColumnValue("PageSettings", Value)
            End Set
        End Property



        <XmlAttribute("LastUpdatedDate")> _
        Public Property LastUpdatedDate() As DateTime
            Get
                Return GetColumnValue(Of DateTime)("LastUpdatedDate")
            End Get

            Set(ByVal value As DateTime)
                SetColumnValue("LastUpdatedDate", Value)
            End Set
        End Property




#End Region










#Region "ForeignKey Methods"

        ''' <summary>
        ''' Returns a AspnetPaths ActiveRecord object related to this AspnetPersonalizationPerUser
        ''' </summary>
        Public Property AspnetPaths() As InfoPool.Data.AspnetPaths
            Get
                Return InfoPool.Data.AspnetPaths.FetchByID(Me.PathId)
            End Get
            Set(ByVal value As InfoPool.Data.AspnetPaths)
                SetColumnValue("PathId", Value.PathId)
            End Set
        End Property

        ''' <summary>
        ''' Returns a AspnetUsers ActiveRecord object related to this AspnetPersonalizationPerUser
        ''' </summary>
        Public Property AspnetUsers() As InfoPool.Data.AspnetUsers
            Get
                Return InfoPool.Data.AspnetUsers.FetchByID(Me.UserId)
            End Get
            Set(ByVal value As InfoPool.Data.AspnetUsers)
                SetColumnValue("UserId", Value.UserId)
            End Set
        End Property

#End Region



        'no ManyToMany tables defined (0)


#Region "ObjectDataSource support"

        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Insert(ByVal varId As Guid, ByVal varPathId As Nullable(Of Guid), ByVal varUserId As Nullable(Of Guid), ByVal varPageSettings As Byte(), ByVal varLastUpdatedDate As DateTime)
            Dim item As AspnetPersonalizationPerUser = New AspnetPersonalizationPerUser()

            item.Id = varId

            item.PathId = varPathId

            item.UserId = varUserId

            item.PageSettings = varPageSettings

            item.LastUpdatedDate = varLastUpdatedDate

            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Update(ByVal varId As Guid, ByVal varPathId As Nullable(Of Guid), ByVal varUserId As Nullable(Of Guid), ByVal varPageSettings As Byte(), ByVal varLastUpdatedDate As DateTime)
            Dim item As AspnetPersonalizationPerUser = New AspnetPersonalizationPerUser()

            item.Id = varId

            item.PathId = varPathId

            item.UserId = varUserId

            item.PageSettings = varPageSettings

            item.LastUpdatedDate = varLastUpdatedDate

            item.IsNew = False
            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
#End Region
#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared Id As String = "Id"

            Public Shared PathId As String = "PathId"

            Public Shared UserId As String = "UserId"

            Public Shared PageSettings As String = "PageSettings"

            Public Shared LastUpdatedDate As String = "LastUpdatedDate"

        End Structure
#End Region
    End Class
End Namespace
