Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the AspnetProfile class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class AspnetProfileCollection
        Inherits ActiveList(Of AspnetProfile, AspnetProfileCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is an ActiveRecord class which wraps the aspnet_Profile table.
    ''' </summary>
    <Serializable()> _
    Partial Public Class AspnetProfile
        Inherits ActiveRecord(Of AspnetProfile)
#Region ".ctors and Default Settings"

        Public Sub New()
            SetSQLProps()
            InitSetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub
        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByKey(keyID)
        End Sub
        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByParam(columnName, columnValue)
        End Sub
        Private Sub InitSetDefaults()
            SetDefaults()
        End Sub

        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region

#Region "Schema and Query Accessor"

        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If BaseSchema Is Nothing Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property
        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("aspnet_Profile", TableType.Table, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"
                'columns


                Dim colvarUserId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarUserId.ColumnName = "UserId"
                colvarUserId.DataType = DbType.Guid
                colvarUserId.MaxLength = 0
                colvarUserId.AutoIncrement = False
                colvarUserId.IsNullable = False
                colvarUserId.IsPrimaryKey = True
                colvarUserId.IsForeignKey = True
                colvarUserId.IsReadOnly = False


                colvarUserId.ForeignKeyTableName = "aspnet_Users"

                schema.Columns.Add(colvarUserId)

                Dim colvarPropertyNames As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarPropertyNames.ColumnName = "PropertyNames"
                colvarPropertyNames.DataType = DbType.String
                colvarPropertyNames.MaxLength = 1073741823
                colvarPropertyNames.AutoIncrement = False
                colvarPropertyNames.IsNullable = False
                colvarPropertyNames.IsPrimaryKey = False
                colvarPropertyNames.IsForeignKey = False
                colvarPropertyNames.IsReadOnly = False


                schema.Columns.Add(colvarPropertyNames)

                Dim colvarPropertyValuesString As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarPropertyValuesString.ColumnName = "PropertyValuesString"
                colvarPropertyValuesString.DataType = DbType.String
                colvarPropertyValuesString.MaxLength = 1073741823
                colvarPropertyValuesString.AutoIncrement = False
                colvarPropertyValuesString.IsNullable = False
                colvarPropertyValuesString.IsPrimaryKey = False
                colvarPropertyValuesString.IsForeignKey = False
                colvarPropertyValuesString.IsReadOnly = False


                schema.Columns.Add(colvarPropertyValuesString)

                Dim colvarPropertyValuesBinary As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarPropertyValuesBinary.ColumnName = "PropertyValuesBinary"
                colvarPropertyValuesBinary.DataType = DbType.Binary
                colvarPropertyValuesBinary.MaxLength = 2147483647
                colvarPropertyValuesBinary.AutoIncrement = False
                colvarPropertyValuesBinary.IsNullable = False
                colvarPropertyValuesBinary.IsPrimaryKey = False
                colvarPropertyValuesBinary.IsForeignKey = False
                colvarPropertyValuesBinary.IsReadOnly = False


                schema.Columns.Add(colvarPropertyValuesBinary)

                Dim colvarLastUpdatedDate As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarLastUpdatedDate.ColumnName = "LastUpdatedDate"
                colvarLastUpdatedDate.DataType = DbType.DateTime
                colvarLastUpdatedDate.MaxLength = 0
                colvarLastUpdatedDate.AutoIncrement = False
                colvarLastUpdatedDate.IsNullable = False
                colvarLastUpdatedDate.IsPrimaryKey = False
                colvarLastUpdatedDate.IsForeignKey = False
                colvarLastUpdatedDate.IsReadOnly = False


                schema.Columns.Add(colvarLastUpdatedDate)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("aspnet_Profile", schema)
            End If
        End Sub
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function

#End Region

#Region "Props"


        <XmlAttribute("UserId")> _
        Public Property UserId() As Guid
            Get
                Return GetColumnValue(Of Guid)("UserId")
            End Get

            Set(ByVal value As Guid)
                SetColumnValue("UserId", Value)
            End Set
        End Property



        <XmlAttribute("PropertyNames")> _
        Public Property PropertyNames() As String
            Get
                Return GetColumnValue(Of String)("PropertyNames")
            End Get

            Set(ByVal value As String)
                SetColumnValue("PropertyNames", Value)
            End Set
        End Property



        <XmlAttribute("PropertyValuesString")> _
        Public Property PropertyValuesString() As String
            Get
                Return GetColumnValue(Of String)("PropertyValuesString")
            End Get

            Set(ByVal value As String)
                SetColumnValue("PropertyValuesString", Value)
            End Set
        End Property



        <XmlAttribute("PropertyValuesBinary")> _
        Public Property PropertyValuesBinary() As Byte()
            Get
                Return GetColumnValue(Of Byte())("PropertyValuesBinary")
            End Get

            Set(ByVal value As Byte())
                SetColumnValue("PropertyValuesBinary", Value)
            End Set
        End Property



        <XmlAttribute("LastUpdatedDate")> _
        Public Property LastUpdatedDate() As DateTime
            Get
                Return GetColumnValue(Of DateTime)("LastUpdatedDate")
            End Get

            Set(ByVal value As DateTime)
                SetColumnValue("LastUpdatedDate", Value)
            End Set
        End Property




#End Region










#Region "ForeignKey Methods"

        ''' <summary>
        ''' Returns a AspnetUsers ActiveRecord object related to this AspnetProfile
        ''' </summary>
        Public Property AspnetUsers() As InfoPool.Data.AspnetUsers
            Get
                Return InfoPool.Data.AspnetUsers.FetchByID(Me.UserId)
            End Get
            Set(ByVal value As InfoPool.Data.AspnetUsers)
                SetColumnValue("UserId", Value.UserId)
            End Set
        End Property

#End Region



        'no ManyToMany tables defined (0)


#Region "ObjectDataSource support"

        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Insert(ByVal varUserId As Guid, ByVal varPropertyNames As String, ByVal varPropertyValuesString As String, ByVal varPropertyValuesBinary As Byte(), ByVal varLastUpdatedDate As DateTime)
            Dim item As AspnetProfile = New AspnetProfile()

            item.UserId = varUserId

            item.PropertyNames = varPropertyNames

            item.PropertyValuesString = varPropertyValuesString

            item.PropertyValuesBinary = varPropertyValuesBinary

            item.LastUpdatedDate = varLastUpdatedDate

            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Update(ByVal varUserId As Guid, ByVal varPropertyNames As String, ByVal varPropertyValuesString As String, ByVal varPropertyValuesBinary As Byte(), ByVal varLastUpdatedDate As DateTime)
            Dim item As AspnetProfile = New AspnetProfile()

            item.UserId = varUserId

            item.PropertyNames = varPropertyNames

            item.PropertyValuesString = varPropertyValuesString

            item.PropertyValuesBinary = varPropertyValuesBinary

            item.LastUpdatedDate = varLastUpdatedDate

            item.IsNew = False
            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
#End Region
#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared UserId As String = "UserId"

            Public Shared PropertyNames As String = "PropertyNames"

            Public Shared PropertyValuesString As String = "PropertyValuesString"

            Public Shared PropertyValuesBinary As String = "PropertyValuesBinary"

            Public Shared LastUpdatedDate As String = "LastUpdatedDate"

        End Structure
#End Region
    End Class
End Namespace
