Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for aspnet_Roles
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class AspnetRolesController

        ' Preload our schema..
        Dim thisSchemaLoad As AspnetRoles = New AspnetRoles()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As AspnetRolesCollection

            Dim coll As AspnetRolesCollection = New AspnetRolesCollection()
            Dim qry As Query = New Query(AspnetRoles.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal RoleId As Object) As AspnetRolesCollection

            Dim coll As AspnetRolesCollection = New AspnetRolesCollection().Where("RoleId", RoleId).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As AspnetRolesCollection

            Dim coll As AspnetRolesCollection = New AspnetRolesCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal RoleId As Object) As Boolean

            Return (AspnetRoles.Delete(RoleId) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal RoleId As Object) As Boolean

            Return (AspnetRoles.Destroy(RoleId) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal ApplicationId As Guid, ByVal RoleId As Guid, ByVal RoleName As String, ByVal LoweredRoleName As String, ByVal Description As String)

            Dim item As AspnetRoles = New AspnetRoles()

            item.ApplicationId = ApplicationId

            item.RoleId = RoleId

            item.RoleName = RoleName

            item.LoweredRoleName = LoweredRoleName

            item.Description = Description


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal ApplicationId As Guid, ByVal RoleId As Guid, ByVal RoleName As String, ByVal LoweredRoleName As String, ByVal Description As String)

            Dim item As AspnetRoles = New AspnetRoles()

            item.ApplicationId = ApplicationId

            item.RoleId = RoleId

            item.RoleName = RoleName

            item.LoweredRoleName = LoweredRoleName

            item.Description = Description

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
