Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the AspnetSchemaVersion class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class AspnetSchemaVersionCollection
        Inherits ActiveList(Of AspnetSchemaVersion, AspnetSchemaVersionCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is an ActiveRecord class which wraps the aspnet_SchemaVersions table.
    ''' </summary>
    <Serializable()> _
    Partial Public Class AspnetSchemaVersion
        Inherits ActiveRecord(Of AspnetSchemaVersion)
#Region ".ctors and Default Settings"

        Public Sub New()
            SetSQLProps()
            InitSetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub
        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByKey(keyID)
        End Sub
        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByParam(columnName, columnValue)
        End Sub
        Private Sub InitSetDefaults()
            SetDefaults()
        End Sub

        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region

#Region "Schema and Query Accessor"

        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If BaseSchema Is Nothing Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property
        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("aspnet_SchemaVersions", TableType.Table, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"
                'columns


                Dim colvarFeature As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarFeature.ColumnName = "Feature"
                colvarFeature.DataType = DbType.String
                colvarFeature.MaxLength = 128
                colvarFeature.AutoIncrement = False
                colvarFeature.IsNullable = False
                colvarFeature.IsPrimaryKey = True
                colvarFeature.IsForeignKey = False
                colvarFeature.IsReadOnly = False


                schema.Columns.Add(colvarFeature)

                Dim colvarCompatibleSchemaVersion As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarCompatibleSchemaVersion.ColumnName = "CompatibleSchemaVersion"
                colvarCompatibleSchemaVersion.DataType = DbType.String
                colvarCompatibleSchemaVersion.MaxLength = 128
                colvarCompatibleSchemaVersion.AutoIncrement = False
                colvarCompatibleSchemaVersion.IsNullable = False
                colvarCompatibleSchemaVersion.IsPrimaryKey = True
                colvarCompatibleSchemaVersion.IsForeignKey = False
                colvarCompatibleSchemaVersion.IsReadOnly = False


                schema.Columns.Add(colvarCompatibleSchemaVersion)

                Dim colvarIsCurrentVersion As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarIsCurrentVersion.ColumnName = "IsCurrentVersion"
                colvarIsCurrentVersion.DataType = DbType.Boolean
                colvarIsCurrentVersion.MaxLength = 0
                colvarIsCurrentVersion.AutoIncrement = False
                colvarIsCurrentVersion.IsNullable = False
                colvarIsCurrentVersion.IsPrimaryKey = False
                colvarIsCurrentVersion.IsForeignKey = False
                colvarIsCurrentVersion.IsReadOnly = False


                schema.Columns.Add(colvarIsCurrentVersion)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("aspnet_SchemaVersions", schema)
            End If
        End Sub
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function

#End Region

#Region "Props"


        <XmlAttribute("Feature")> _
        Public Property Feature() As String
            Get
                Return GetColumnValue(Of String)("Feature")
            End Get

            Set(ByVal value As String)
                SetColumnValue("Feature", Value)
            End Set
        End Property



        <XmlAttribute("CompatibleSchemaVersion")> _
        Public Property CompatibleSchemaVersion() As String
            Get
                Return GetColumnValue(Of String)("CompatibleSchemaVersion")
            End Get

            Set(ByVal value As String)
                SetColumnValue("CompatibleSchemaVersion", Value)
            End Set
        End Property



        <XmlAttribute("IsCurrentVersion")> _
        Public Property IsCurrentVersion() As Boolean
            Get
                Return GetColumnValue(Of Boolean)("IsCurrentVersion")
            End Get

            Set(ByVal value As Boolean)
                SetColumnValue("IsCurrentVersion", Value)
            End Set
        End Property




#End Region










        'no foreign key tables defined (0)



        'no ManyToMany tables defined (0)


#Region "ObjectDataSource support"

        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Insert(ByVal varFeature As String, ByVal varCompatibleSchemaVersion As String, ByVal varIsCurrentVersion As Boolean)
            Dim item As AspnetSchemaVersion = New AspnetSchemaVersion()

            item.Feature = varFeature

            item.CompatibleSchemaVersion = varCompatibleSchemaVersion

            item.IsCurrentVersion = varIsCurrentVersion

            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Update(ByVal varFeature As String, ByVal varCompatibleSchemaVersion As String, ByVal varIsCurrentVersion As Boolean)
            Dim item As AspnetSchemaVersion = New AspnetSchemaVersion()

            item.Feature = varFeature

            item.CompatibleSchemaVersion = varCompatibleSchemaVersion

            item.IsCurrentVersion = varIsCurrentVersion

            item.IsNew = False
            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
#End Region
#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared Feature As String = "Feature"

            Public Shared CompatibleSchemaVersion As String = "CompatibleSchemaVersion"

            Public Shared IsCurrentVersion As String = "IsCurrentVersion"

        End Structure
#End Region
    End Class
End Namespace
