Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for aspnet_SchemaVersions
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class AspnetSchemaVersionController

        ' Preload our schema..
        Dim thisSchemaLoad As AspnetSchemaVersion = New AspnetSchemaVersion()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As AspnetSchemaVersionCollection

            Dim coll As AspnetSchemaVersionCollection = New AspnetSchemaVersionCollection()
            Dim qry As Query = New Query(AspnetSchemaVersion.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Feature As Object) As AspnetSchemaVersionCollection

            Dim coll As AspnetSchemaVersionCollection = New AspnetSchemaVersionCollection().Where("Feature", Feature).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As AspnetSchemaVersionCollection

            Dim coll As AspnetSchemaVersionCollection = New AspnetSchemaVersionCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Feature As Object) As Boolean

            Return (AspnetSchemaVersion.Delete(Feature) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Feature As Object) As Boolean

            Return (AspnetSchemaVersion.Destroy(Feature) = 1)

        End Function


        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Feature As String, ByVal CompatibleSchemaVersion As String) As Boolean
            Dim qry As Query = New Query(AspnetSchemaVersion.Schema)
            qry.QueryType = QueryType.Delete
            qry.AddWhere("Feature", Feature).AND("CompatibleSchemaVersion", CompatibleSchemaVersion)
            qry.Execute()
            Return True
        End Function



        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal Feature As String, ByVal CompatibleSchemaVersion As String, ByVal IsCurrentVersion As Boolean)

            Dim item As AspnetSchemaVersion = New AspnetSchemaVersion()

            item.Feature = Feature

            item.CompatibleSchemaVersion = CompatibleSchemaVersion

            item.IsCurrentVersion = IsCurrentVersion


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Feature As String, ByVal CompatibleSchemaVersion As String, ByVal IsCurrentVersion As Boolean)

            Dim item As AspnetSchemaVersion = New AspnetSchemaVersion()

            item.Feature = Feature

            item.CompatibleSchemaVersion = CompatibleSchemaVersion

            item.IsCurrentVersion = IsCurrentVersion

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
