Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the AspnetUser class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class AspnetUserCollection
        Inherits ActiveList(Of AspnetUser, AspnetUserCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is an ActiveRecord class which wraps the aspnet_Users table.
    ''' </summary>
    <Serializable()> _
    Partial Public Class AspnetUser
        Inherits ActiveRecord(Of AspnetUser)
#Region ".ctors and Default Settings"

        Public Sub New()
            SetSQLProps()
            InitSetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub
        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByKey(keyID)
        End Sub
        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByParam(columnName, columnValue)
        End Sub
        Private Sub InitSetDefaults()
            SetDefaults()
        End Sub

        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region

#Region "Schema and Query Accessor"

        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If BaseSchema Is Nothing Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property
        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("aspnet_Users", TableType.Table, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"
                'columns


                Dim colvarApplicationId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarApplicationId.ColumnName = "ApplicationId"
                colvarApplicationId.DataType = DbType.Guid
                colvarApplicationId.MaxLength = 0
                colvarApplicationId.AutoIncrement = False
                colvarApplicationId.IsNullable = False
                colvarApplicationId.IsPrimaryKey = False
                colvarApplicationId.IsForeignKey = True
                colvarApplicationId.IsReadOnly = False


                colvarApplicationId.ForeignKeyTableName = "aspnet_Applications"

                schema.Columns.Add(colvarApplicationId)

                Dim colvarUserId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarUserId.ColumnName = "UserId"
                colvarUserId.DataType = DbType.Guid
                colvarUserId.MaxLength = 0
                colvarUserId.AutoIncrement = False
                colvarUserId.IsNullable = False
                colvarUserId.IsPrimaryKey = True
                colvarUserId.IsForeignKey = False
                colvarUserId.IsReadOnly = False

                colvarUserId.DefaultSetting = "(newid())"


                schema.Columns.Add(colvarUserId)

                Dim colvarUserName As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarUserName.ColumnName = "UserName"
                colvarUserName.DataType = DbType.String
                colvarUserName.MaxLength = 256
                colvarUserName.AutoIncrement = False
                colvarUserName.IsNullable = False
                colvarUserName.IsPrimaryKey = False
                colvarUserName.IsForeignKey = False
                colvarUserName.IsReadOnly = False


                schema.Columns.Add(colvarUserName)

                Dim colvarLoweredUserName As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarLoweredUserName.ColumnName = "LoweredUserName"
                colvarLoweredUserName.DataType = DbType.String
                colvarLoweredUserName.MaxLength = 256
                colvarLoweredUserName.AutoIncrement = False
                colvarLoweredUserName.IsNullable = False
                colvarLoweredUserName.IsPrimaryKey = False
                colvarLoweredUserName.IsForeignKey = False
                colvarLoweredUserName.IsReadOnly = False


                schema.Columns.Add(colvarLoweredUserName)

                Dim colvarMobileAlias As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarMobileAlias.ColumnName = "MobileAlias"
                colvarMobileAlias.DataType = DbType.String
                colvarMobileAlias.MaxLength = 16
                colvarMobileAlias.AutoIncrement = False
                colvarMobileAlias.IsNullable = True
                colvarMobileAlias.IsPrimaryKey = False
                colvarMobileAlias.IsForeignKey = False
                colvarMobileAlias.IsReadOnly = False

                colvarMobileAlias.DefaultSetting = "(NULL)"


                schema.Columns.Add(colvarMobileAlias)

                Dim colvarIsAnonymous As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarIsAnonymous.ColumnName = "IsAnonymous"
                colvarIsAnonymous.DataType = DbType.Boolean
                colvarIsAnonymous.MaxLength = 0
                colvarIsAnonymous.AutoIncrement = False
                colvarIsAnonymous.IsNullable = False
                colvarIsAnonymous.IsPrimaryKey = False
                colvarIsAnonymous.IsForeignKey = False
                colvarIsAnonymous.IsReadOnly = False

                colvarIsAnonymous.DefaultSetting = "((0))"


                schema.Columns.Add(colvarIsAnonymous)

                Dim colvarLastActivityDate As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarLastActivityDate.ColumnName = "LastActivityDate"
                colvarLastActivityDate.DataType = DbType.DateTime
                colvarLastActivityDate.MaxLength = 0
                colvarLastActivityDate.AutoIncrement = False
                colvarLastActivityDate.IsNullable = False
                colvarLastActivityDate.IsPrimaryKey = False
                colvarLastActivityDate.IsForeignKey = False
                colvarLastActivityDate.IsReadOnly = False


                schema.Columns.Add(colvarLastActivityDate)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("aspnet_Users", schema)
            End If
        End Sub
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function

#End Region

#Region "Props"


        <XmlAttribute("ApplicationId")> _
        Public Property ApplicationId() As Guid
            Get
                Return GetColumnValue(Of Guid)("ApplicationId")
            End Get

            Set(ByVal value As Guid)
                SetColumnValue("ApplicationId", Value)
            End Set
        End Property



        <XmlAttribute("UserId")> _
        Public Property UserId() As Guid
            Get
                Return GetColumnValue(Of Guid)("UserId")
            End Get

            Set(ByVal value As Guid)
                SetColumnValue("UserId", Value)
            End Set
        End Property



        <XmlAttribute("UserName")> _
        Public Property UserName() As String
            Get
                Return GetColumnValue(Of String)("UserName")
            End Get

            Set(ByVal value As String)
                SetColumnValue("UserName", Value)
            End Set
        End Property



        <XmlAttribute("LoweredUserName")> _
        Public Property LoweredUserName() As String
            Get
                Return GetColumnValue(Of String)("LoweredUserName")
            End Get

            Set(ByVal value As String)
                SetColumnValue("LoweredUserName", Value)
            End Set
        End Property



        <XmlAttribute("MobileAlias")> _
        Public Property MobileAlias() As String
            Get
                Return GetColumnValue(Of String)("MobileAlias")
            End Get

            Set(ByVal value As String)
                SetColumnValue("MobileAlias", Value)
            End Set
        End Property



        <XmlAttribute("IsAnonymous")> _
        Public Property IsAnonymous() As Boolean
            Get
                Return GetColumnValue(Of Boolean)("IsAnonymous")
            End Get

            Set(ByVal value As Boolean)
                SetColumnValue("IsAnonymous", Value)
            End Set
        End Property



        <XmlAttribute("LastActivityDate")> _
        Public Property LastActivityDate() As DateTime
            Get
                Return GetColumnValue(Of DateTime)("LastActivityDate")
            End Get

            Set(ByVal value As DateTime)
                SetColumnValue("LastActivityDate", Value)
            End Set
        End Property




#End Region




#Region "PrimaryKey Methods"

        Public Function AspnetMembershipRecords() As InfoPool.Data.AspnetMembershipCollection

            Return New InfoPool.Data.AspnetMembershipCollection().Where(AspnetMembership.Columns.UserId, UserId).Load()

        End Function

        Public Function AspnetPersonalizationPerUserRecords() As InfoPool.Data.AspnetPersonalizationPerUserCollection

            Return New InfoPool.Data.AspnetPersonalizationPerUserCollection().Where(AspnetPersonalizationPerUser.Columns.UserId, UserId).Load()

        End Function

        Public Function AspnetProfileRecords() As InfoPool.Data.AspnetProfileCollection

            Return New InfoPool.Data.AspnetProfileCollection().Where(AspnetProfile.Columns.UserId, UserId).Load()

        End Function

        Public Function AspnetUsersInRoles() As InfoPool.Data.AspnetUsersInRoleCollection

            Return New InfoPool.Data.AspnetUsersInRoleCollection().Where(AspnetUsersInRole.Columns.UserId, UserId).Load()

        End Function

#End Region







#Region "ForeignKey Methods"

        ''' <summary>
        ''' Returns a AspnetApplication ActiveRecord object related to this AspnetUser
        ''' </summary>
        Public Property AspnetApplication() As InfoPool.Data.AspnetApplication
            Get
                Return InfoPool.Data.AspnetApplication.FetchByID(Me.ApplicationId)
            End Get
            Set(ByVal value As InfoPool.Data.AspnetApplication)
                SetColumnValue("ApplicationId", Value.ApplicationId)
            End Set
        End Property

#End Region



#Region "Many To Many Helpers"


        Public Function GetAspnetRoleCollection() As InfoPool.Data.AspnetRoleCollection
            Return AspnetUser.GetAspnetRoleCollection(Me.UserId)
        End Function

        Public Shared Function GetAspnetRoleCollection(ByVal varUserId As Guid) As InfoPool.Data.AspnetRoleCollection

            Dim cmd As SubSonic.QueryCommand = New SubSonic.QueryCommand("SELECT * FROM aspnet_Roles INNER JOIN aspnet_UsersInRoles ON aspnet_Roles.RoleId=aspnet_UsersInRoles.RoleId WHERE aspnet_UsersInRoles.UserId=@UserId", AspnetUser.Schema.Provider.Name)

            cmd.AddParameter("@UserId", varUserId, DbType.Guid)
            Dim rdr As IDataReader = SubSonic.DataService.GetReader(cmd)
            Dim coll As AspnetRoleCollection = New AspnetRoleCollection()
            coll.LoadAndCloseReader(rdr)
            Return coll

        End Function

        Public Shared Sub SaveAspnetRoleMap(ByVal varUserId As Guid, ByVal items As AspnetRoleCollection)

            Dim coll As QueryCommandCollection = New SubSonic.QueryCommandCollection()
            'delete out the existing
            Dim cmdDel As QueryCommand = New QueryCommand("DELETE FROM aspnet_UsersInRoles WHERE UserId=@UserId", AspnetUser.Schema.Provider.Name)
            cmdDel.AddParameter("@UserId", varUserId)
            'add this in
            coll.Add(cmdDel)
            DataService.ExecuteTransaction(coll)
            For Each item As AspnetRole In items
                Dim varAspnetUsersInRole As AspnetUsersInRole = New AspnetUsersInRole()
                varAspnetUsersInRole.SetColumnValue("UserId", varUserId)
                varAspnetUsersInRole.SetColumnValue("RoleId", item.GetPrimaryKeyValue())
                varAspnetUsersInRole.Save()
            Next

        End Sub


        Public Shared Sub SaveAspnetRoleMap(ByVal varUserId As Guid, ByVal itemList As System.Web.UI.WebControls.ListItemCollection)

            Dim coll As QueryCommandCollection = New SubSonic.QueryCommandCollection()
            'delete out the existing
            Dim cmdDel As QueryCommand = New QueryCommand("DELETE FROM aspnet_UsersInRoles WHERE UserId=@UserId", AspnetUser.Schema.Provider.Name)
            cmdDel.AddParameter("@UserId", varUserId)
            'add this in
            coll.Add(cmdDel)
            DataService.ExecuteTransaction(coll)
            For Each l As System.Web.UI.WebControls.ListItem In itemList

                If l.Selected Then

                    Dim varAspnetUsersInRole As AspnetUsersInRole = New AspnetUsersInRole()
                    varAspnetUsersInRole.SetColumnValue("UserId", varUserId)
                    varAspnetUsersInRole.SetColumnValue("RoleId", l.Value)
                    varAspnetUsersInRole.Save()

                End If
            Next
        End Sub

        Public Shared Sub SaveAspnetRoleMap(ByVal varUserId As Guid, ByVal itemList() As Guid)

            Dim coll As QueryCommandCollection = New SubSonic.QueryCommandCollection()
            'delete out the existing
            Dim cmdDel As QueryCommand = New QueryCommand("DELETE FROM aspnet_UsersInRoles WHERE UserId=@UserId", AspnetUser.Schema.Provider.Name)
            cmdDel.AddParameter("@UserId", varUserId)
            'add this in
            coll.Add(cmdDel)
            DataService.ExecuteTransaction(coll)

            For Each item As Guid In itemList

                Dim varAspnetUsersInRole As AspnetUsersInRole = New AspnetUsersInRole()
                varAspnetUsersInRole.SetColumnValue("UserId", varUserId)
                varAspnetUsersInRole.SetColumnValue("RoleId", item)
                varAspnetUsersInRole.Save()
            Next

        End Sub

        Public Shared Sub DeleteAspnetRoleMap(ByVal varUserId As Guid)

            Dim cmdDel As QueryCommand = New QueryCommand("DELETE FROM aspnet_UsersInRoles WHERE UserId=@UserId", AspnetUser.Schema.Provider.Name)
            cmdDel.AddParameter("@UserId", varUserId)
            DataService.ExecuteQuery(cmdDel)
        End Sub




#End Region


#Region "ObjectDataSource support"

        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Insert(ByVal varApplicationId As Guid, ByVal varUserId As Guid, ByVal varUserName As String, ByVal varLoweredUserName As String, ByVal varMobileAlias As String, ByVal varIsAnonymous As Boolean, ByVal varLastActivityDate As DateTime)
            Dim item As AspnetUser = New AspnetUser()

            item.ApplicationId = varApplicationId

            item.UserId = varUserId

            item.UserName = varUserName

            item.LoweredUserName = varLoweredUserName

            item.MobileAlias = varMobileAlias

            item.IsAnonymous = varIsAnonymous

            item.LastActivityDate = varLastActivityDate

            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Update(ByVal varApplicationId As Guid, ByVal varUserId As Guid, ByVal varUserName As String, ByVal varLoweredUserName As String, ByVal varMobileAlias As String, ByVal varIsAnonymous As Boolean, ByVal varLastActivityDate As DateTime)
            Dim item As AspnetUser = New AspnetUser()

            item.ApplicationId = varApplicationId

            item.UserId = varUserId

            item.UserName = varUserName

            item.LoweredUserName = varLoweredUserName

            item.MobileAlias = varMobileAlias

            item.IsAnonymous = varIsAnonymous

            item.LastActivityDate = varLastActivityDate

            item.IsNew = False
            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
#End Region
#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared ApplicationId As String = "ApplicationId"

            Public Shared UserId As String = "UserId"

            Public Shared UserName As String = "UserName"

            Public Shared LoweredUserName As String = "LoweredUserName"

            Public Shared MobileAlias As String = "MobileAlias"

            Public Shared IsAnonymous As String = "IsAnonymous"

            Public Shared LastActivityDate As String = "LastActivityDate"

        End Structure
#End Region
    End Class
End Namespace
