Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the AspnetUsersInRole class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class AspnetUsersInRoleCollection
        Inherits ActiveList(Of AspnetUsersInRole, AspnetUsersInRoleCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is an ActiveRecord class which wraps the aspnet_UsersInRoles table.
    ''' </summary>
    <Serializable()> _
    Partial Public Class AspnetUsersInRole
        Inherits ActiveRecord(Of AspnetUsersInRole)
#Region ".ctors and Default Settings"

        Public Sub New()
            SetSQLProps()
            InitSetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub
        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByKey(keyID)
        End Sub
        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByParam(columnName, columnValue)
        End Sub
        Private Sub InitSetDefaults()
            SetDefaults()
        End Sub

        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region

#Region "Schema and Query Accessor"

        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If BaseSchema Is Nothing Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property
        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("aspnet_UsersInRoles", TableType.Table, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"
                'columns


                Dim colvarUserId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarUserId.ColumnName = "UserId"
                colvarUserId.DataType = DbType.Guid
                colvarUserId.MaxLength = 0
                colvarUserId.AutoIncrement = False
                colvarUserId.IsNullable = False
                colvarUserId.IsPrimaryKey = True
                colvarUserId.IsForeignKey = True
                colvarUserId.IsReadOnly = False


                colvarUserId.ForeignKeyTableName = "aspnet_Users"

                schema.Columns.Add(colvarUserId)

                Dim colvarRoleId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarRoleId.ColumnName = "RoleId"
                colvarRoleId.DataType = DbType.Guid
                colvarRoleId.MaxLength = 0
                colvarRoleId.AutoIncrement = False
                colvarRoleId.IsNullable = False
                colvarRoleId.IsPrimaryKey = True
                colvarRoleId.IsForeignKey = True
                colvarRoleId.IsReadOnly = False


                colvarRoleId.ForeignKeyTableName = "aspnet_Roles"

                schema.Columns.Add(colvarRoleId)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("aspnet_UsersInRoles", schema)
            End If
        End Sub
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function

#End Region

#Region "Props"


        <XmlAttribute("UserId")> _
        Public Property UserId() As Guid
            Get
                Return GetColumnValue(Of Guid)("UserId")
            End Get

            Set(ByVal value As Guid)
                SetColumnValue("UserId", Value)
            End Set
        End Property



        <XmlAttribute("RoleId")> _
        Public Property RoleId() As Guid
            Get
                Return GetColumnValue(Of Guid)("RoleId")
            End Get

            Set(ByVal value As Guid)
                SetColumnValue("RoleId", Value)
            End Set
        End Property




#End Region










#Region "ForeignKey Methods"

        ''' <summary>
        ''' Returns a AspnetRole ActiveRecord object related to this AspnetUsersInRole
        ''' </summary>
        Public Property AspnetRole() As InfoPool.Data.AspnetRole
            Get
                Return InfoPool.Data.AspnetRole.FetchByID(Me.RoleId)
            End Get
            Set(ByVal value As InfoPool.Data.AspnetRole)
                SetColumnValue("RoleId", Value.RoleId)
            End Set
        End Property

        ''' <summary>
        ''' Returns a AspnetUser ActiveRecord object related to this AspnetUsersInRole
        ''' </summary>
        Public Property AspnetUser() As InfoPool.Data.AspnetUser
            Get
                Return InfoPool.Data.AspnetUser.FetchByID(Me.UserId)
            End Get
            Set(ByVal value As InfoPool.Data.AspnetUser)
                SetColumnValue("UserId", Value.UserId)
            End Set
        End Property

#End Region



        'no ManyToMany tables defined (0)


#Region "ObjectDataSource support"

        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Insert(ByVal varUserId As Guid, ByVal varRoleId As Guid)
            Dim item As AspnetUsersInRole = New AspnetUsersInRole()

            item.UserId = varUserId

            item.RoleId = varRoleId

            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Update(ByVal varUserId As Guid, ByVal varRoleId As Guid)
            Dim item As AspnetUsersInRole = New AspnetUsersInRole()

            item.UserId = varUserId

            item.RoleId = varRoleId

            item.IsNew = False
            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
#End Region
#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared UserId As String = "UserId"

            Public Shared RoleId As String = "RoleId"

        End Structure
#End Region
    End Class
End Namespace
