Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for aspnet_UsersInRoles
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class AspnetUsersInRoleController

        ' Preload our schema..
        Dim thisSchemaLoad As AspnetUsersInRole = New AspnetUsersInRole()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As AspnetUsersInRoleCollection

            Dim coll As AspnetUsersInRoleCollection = New AspnetUsersInRoleCollection()
            Dim qry As Query = New Query(AspnetUsersInRole.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal UserId As Object) As AspnetUsersInRoleCollection

            Dim coll As AspnetUsersInRoleCollection = New AspnetUsersInRoleCollection().Where("UserId", UserId).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As AspnetUsersInRoleCollection

            Dim coll As AspnetUsersInRoleCollection = New AspnetUsersInRoleCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal UserId As Object) As Boolean

            Return (AspnetUsersInRole.Delete(UserId) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal UserId As Object) As Boolean

            Return (AspnetUsersInRole.Destroy(UserId) = 1)

        End Function


        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal UserId As Guid, ByVal RoleId As Guid) As Boolean
            Dim qry As Query = New Query(AspnetUsersInRole.Schema)
            qry.QueryType = QueryType.Delete
            qry.AddWhere("UserId", UserId).AND("RoleId", RoleId)
            qry.Execute()
            Return True
        End Function



        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal UserId As Guid, ByVal RoleId As Guid)

            Dim item As AspnetUsersInRole = New AspnetUsersInRole()

            item.UserId = UserId

            item.RoleId = RoleId


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal UserId As Guid, ByVal RoleId As Guid)

            Dim item As AspnetUsersInRole = New AspnetUsersInRole()

            item.UserId = UserId

            item.RoleId = RoleId

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
