Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the AspnetWebEventEvents class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class AspnetWebEventEventsCollection
        Inherits ActiveList(Of AspnetWebEventEvents, AspnetWebEventEventsCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is an ActiveRecord class which wraps the aspnet_WebEvent_Events table.
    ''' </summary>
    <Serializable()> _
    Partial Public Class AspnetWebEventEvents
        Inherits ActiveRecord(Of AspnetWebEventEvents)
#Region ".ctors and Default Settings"

        Public Sub New()
            SetSQLProps()
            InitSetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub
        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByKey(keyID)
        End Sub
        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByParam(columnName, columnValue)
        End Sub
        Private Sub InitSetDefaults()
            SetDefaults()
        End Sub

        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region

#Region "Schema and Query Accessor"

        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If BaseSchema Is Nothing Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property
        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("aspnet_WebEvent_Events", TableType.Table, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"
                'columns


                Dim colvarEventId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarEventId.ColumnName = "EventId"
                colvarEventId.DataType = DbType.AnsiStringFixedLength
                colvarEventId.MaxLength = 32
                colvarEventId.AutoIncrement = False
                colvarEventId.IsNullable = False
                colvarEventId.IsPrimaryKey = True
                colvarEventId.IsForeignKey = False
                colvarEventId.IsReadOnly = False


                schema.Columns.Add(colvarEventId)

                Dim colvarEventTimeUtc As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarEventTimeUtc.ColumnName = "EventTimeUtc"
                colvarEventTimeUtc.DataType = DbType.DateTime
                colvarEventTimeUtc.MaxLength = 0
                colvarEventTimeUtc.AutoIncrement = False
                colvarEventTimeUtc.IsNullable = False
                colvarEventTimeUtc.IsPrimaryKey = False
                colvarEventTimeUtc.IsForeignKey = False
                colvarEventTimeUtc.IsReadOnly = False


                schema.Columns.Add(colvarEventTimeUtc)

                Dim colvarEventTime As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarEventTime.ColumnName = "EventTime"
                colvarEventTime.DataType = DbType.DateTime
                colvarEventTime.MaxLength = 0
                colvarEventTime.AutoIncrement = False
                colvarEventTime.IsNullable = False
                colvarEventTime.IsPrimaryKey = False
                colvarEventTime.IsForeignKey = False
                colvarEventTime.IsReadOnly = False


                schema.Columns.Add(colvarEventTime)

                Dim colvarEventType As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarEventType.ColumnName = "EventType"
                colvarEventType.DataType = DbType.String
                colvarEventType.MaxLength = 256
                colvarEventType.AutoIncrement = False
                colvarEventType.IsNullable = False
                colvarEventType.IsPrimaryKey = False
                colvarEventType.IsForeignKey = False
                colvarEventType.IsReadOnly = False


                schema.Columns.Add(colvarEventType)

                Dim colvarEventSequence As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarEventSequence.ColumnName = "EventSequence"
                colvarEventSequence.DataType = DbType.Decimal
                colvarEventSequence.MaxLength = 0
                colvarEventSequence.AutoIncrement = False
                colvarEventSequence.IsNullable = False
                colvarEventSequence.IsPrimaryKey = False
                colvarEventSequence.IsForeignKey = False
                colvarEventSequence.IsReadOnly = False


                schema.Columns.Add(colvarEventSequence)

                Dim colvarEventOccurrence As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarEventOccurrence.ColumnName = "EventOccurrence"
                colvarEventOccurrence.DataType = DbType.Decimal
                colvarEventOccurrence.MaxLength = 0
                colvarEventOccurrence.AutoIncrement = False
                colvarEventOccurrence.IsNullable = False
                colvarEventOccurrence.IsPrimaryKey = False
                colvarEventOccurrence.IsForeignKey = False
                colvarEventOccurrence.IsReadOnly = False


                schema.Columns.Add(colvarEventOccurrence)

                Dim colvarEventCode As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarEventCode.ColumnName = "EventCode"
                colvarEventCode.DataType = DbType.Int32
                colvarEventCode.MaxLength = 0
                colvarEventCode.AutoIncrement = False
                colvarEventCode.IsNullable = False
                colvarEventCode.IsPrimaryKey = False
                colvarEventCode.IsForeignKey = False
                colvarEventCode.IsReadOnly = False


                schema.Columns.Add(colvarEventCode)

                Dim colvarEventDetailCode As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarEventDetailCode.ColumnName = "EventDetailCode"
                colvarEventDetailCode.DataType = DbType.Int32
                colvarEventDetailCode.MaxLength = 0
                colvarEventDetailCode.AutoIncrement = False
                colvarEventDetailCode.IsNullable = False
                colvarEventDetailCode.IsPrimaryKey = False
                colvarEventDetailCode.IsForeignKey = False
                colvarEventDetailCode.IsReadOnly = False


                schema.Columns.Add(colvarEventDetailCode)

                Dim colvarMessage As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarMessage.ColumnName = "Message"
                colvarMessage.DataType = DbType.String
                colvarMessage.MaxLength = 1024
                colvarMessage.AutoIncrement = False
                colvarMessage.IsNullable = True
                colvarMessage.IsPrimaryKey = False
                colvarMessage.IsForeignKey = False
                colvarMessage.IsReadOnly = False


                schema.Columns.Add(colvarMessage)

                Dim colvarApplicationPath As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarApplicationPath.ColumnName = "ApplicationPath"
                colvarApplicationPath.DataType = DbType.String
                colvarApplicationPath.MaxLength = 256
                colvarApplicationPath.AutoIncrement = False
                colvarApplicationPath.IsNullable = True
                colvarApplicationPath.IsPrimaryKey = False
                colvarApplicationPath.IsForeignKey = False
                colvarApplicationPath.IsReadOnly = False


                schema.Columns.Add(colvarApplicationPath)

                Dim colvarApplicationVirtualPath As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarApplicationVirtualPath.ColumnName = "ApplicationVirtualPath"
                colvarApplicationVirtualPath.DataType = DbType.String
                colvarApplicationVirtualPath.MaxLength = 256
                colvarApplicationVirtualPath.AutoIncrement = False
                colvarApplicationVirtualPath.IsNullable = True
                colvarApplicationVirtualPath.IsPrimaryKey = False
                colvarApplicationVirtualPath.IsForeignKey = False
                colvarApplicationVirtualPath.IsReadOnly = False


                schema.Columns.Add(colvarApplicationVirtualPath)

                Dim colvarMachineName As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarMachineName.ColumnName = "MachineName"
                colvarMachineName.DataType = DbType.String
                colvarMachineName.MaxLength = 256
                colvarMachineName.AutoIncrement = False
                colvarMachineName.IsNullable = False
                colvarMachineName.IsPrimaryKey = False
                colvarMachineName.IsForeignKey = False
                colvarMachineName.IsReadOnly = False


                schema.Columns.Add(colvarMachineName)

                Dim colvarRequestUrl As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarRequestUrl.ColumnName = "RequestUrl"
                colvarRequestUrl.DataType = DbType.String
                colvarRequestUrl.MaxLength = 1024
                colvarRequestUrl.AutoIncrement = False
                colvarRequestUrl.IsNullable = True
                colvarRequestUrl.IsPrimaryKey = False
                colvarRequestUrl.IsForeignKey = False
                colvarRequestUrl.IsReadOnly = False


                schema.Columns.Add(colvarRequestUrl)

                Dim colvarExceptionType As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarExceptionType.ColumnName = "ExceptionType"
                colvarExceptionType.DataType = DbType.String
                colvarExceptionType.MaxLength = 256
                colvarExceptionType.AutoIncrement = False
                colvarExceptionType.IsNullable = True
                colvarExceptionType.IsPrimaryKey = False
                colvarExceptionType.IsForeignKey = False
                colvarExceptionType.IsReadOnly = False


                schema.Columns.Add(colvarExceptionType)

                Dim colvarDetails As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarDetails.ColumnName = "Details"
                colvarDetails.DataType = DbType.String
                colvarDetails.MaxLength = 1073741823
                colvarDetails.AutoIncrement = False
                colvarDetails.IsNullable = True
                colvarDetails.IsPrimaryKey = False
                colvarDetails.IsForeignKey = False
                colvarDetails.IsReadOnly = False


                schema.Columns.Add(colvarDetails)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("aspnet_WebEvent_Events", schema)
            End If
        End Sub
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function

#End Region

#Region "Props"


        <XmlAttribute("EventId")> _
        Public Property EventId() As String
            Get
                Return GetColumnValue(Of String)("EventId")
            End Get

            Set(ByVal value As String)
                SetColumnValue("EventId", Value)
            End Set
        End Property



        <XmlAttribute("EventTimeUtc")> _
        Public Property EventTimeUtc() As DateTime
            Get
                Return GetColumnValue(Of DateTime)("EventTimeUtc")
            End Get

            Set(ByVal value As DateTime)
                SetColumnValue("EventTimeUtc", Value)
            End Set
        End Property



        <XmlAttribute("EventTime")> _
        Public Property EventTime() As DateTime
            Get
                Return GetColumnValue(Of DateTime)("EventTime")
            End Get

            Set(ByVal value As DateTime)
                SetColumnValue("EventTime", Value)
            End Set
        End Property



        <XmlAttribute("EventType")> _
        Public Property EventType() As String
            Get
                Return GetColumnValue(Of String)("EventType")
            End Get

            Set(ByVal value As String)
                SetColumnValue("EventType", Value)
            End Set
        End Property



        <XmlAttribute("EventSequence")> _
        Public Property EventSequence() As Decimal
            Get
                Return GetColumnValue(Of Decimal)("EventSequence")
            End Get

            Set(ByVal value As Decimal)
                SetColumnValue("EventSequence", Value)
            End Set
        End Property



        <XmlAttribute("EventOccurrence")> _
        Public Property EventOccurrence() As Decimal
            Get
                Return GetColumnValue(Of Decimal)("EventOccurrence")
            End Get

            Set(ByVal value As Decimal)
                SetColumnValue("EventOccurrence", Value)
            End Set
        End Property



        <XmlAttribute("EventCode")> _
        Public Property EventCode() As Integer
            Get
                Return GetColumnValue(Of Integer)("EventCode")
            End Get

            Set(ByVal value As Integer)
                SetColumnValue("EventCode", Value)
            End Set
        End Property



        <XmlAttribute("EventDetailCode")> _
        Public Property EventDetailCode() As Integer
            Get
                Return GetColumnValue(Of Integer)("EventDetailCode")
            End Get

            Set(ByVal value As Integer)
                SetColumnValue("EventDetailCode", Value)
            End Set
        End Property



        <XmlAttribute("Message")> _
        Public Property Message() As String
            Get
                Return GetColumnValue(Of String)("Message")
            End Get

            Set(ByVal value As String)
                SetColumnValue("Message", Value)
            End Set
        End Property



        <XmlAttribute("ApplicationPath")> _
        Public Property ApplicationPath() As String
            Get
                Return GetColumnValue(Of String)("ApplicationPath")
            End Get

            Set(ByVal value As String)
                SetColumnValue("ApplicationPath", Value)
            End Set
        End Property



        <XmlAttribute("ApplicationVirtualPath")> _
        Public Property ApplicationVirtualPath() As String
            Get
                Return GetColumnValue(Of String)("ApplicationVirtualPath")
            End Get

            Set(ByVal value As String)
                SetColumnValue("ApplicationVirtualPath", Value)
            End Set
        End Property



        <XmlAttribute("MachineName")> _
        Public Property MachineName() As String
            Get
                Return GetColumnValue(Of String)("MachineName")
            End Get

            Set(ByVal value As String)
                SetColumnValue("MachineName", Value)
            End Set
        End Property



        <XmlAttribute("RequestUrl")> _
        Public Property RequestUrl() As String
            Get
                Return GetColumnValue(Of String)("RequestUrl")
            End Get

            Set(ByVal value As String)
                SetColumnValue("RequestUrl", Value)
            End Set
        End Property



        <XmlAttribute("ExceptionType")> _
        Public Property ExceptionType() As String
            Get
                Return GetColumnValue(Of String)("ExceptionType")
            End Get

            Set(ByVal value As String)
                SetColumnValue("ExceptionType", Value)
            End Set
        End Property



        <XmlAttribute("Details")> _
        Public Property Details() As String
            Get
                Return GetColumnValue(Of String)("Details")
            End Get

            Set(ByVal value As String)
                SetColumnValue("Details", Value)
            End Set
        End Property




#End Region










        'no foreign key tables defined (0)



        'no ManyToMany tables defined (0)


#Region "ObjectDataSource support"

        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Insert(ByVal varEventId As String, ByVal varEventTimeUtc As DateTime, ByVal varEventTime As DateTime, ByVal varEventType As String, ByVal varEventSequence As Decimal, ByVal varEventOccurrence As Decimal, ByVal varEventCode As Integer, ByVal varEventDetailCode As Integer, ByVal varMessage As String, ByVal varApplicationPath As String, ByVal varApplicationVirtualPath As String, ByVal varMachineName As String, ByVal varRequestUrl As String, ByVal varExceptionType As String, ByVal varDetails As String)
            Dim item As AspnetWebEventEvents = New AspnetWebEventEvents()

            item.EventId = varEventId

            item.EventTimeUtc = varEventTimeUtc

            item.EventTime = varEventTime

            item.EventType = varEventType

            item.EventSequence = varEventSequence

            item.EventOccurrence = varEventOccurrence

            item.EventCode = varEventCode

            item.EventDetailCode = varEventDetailCode

            item.Message = varMessage

            item.ApplicationPath = varApplicationPath

            item.ApplicationVirtualPath = varApplicationVirtualPath

            item.MachineName = varMachineName

            item.RequestUrl = varRequestUrl

            item.ExceptionType = varExceptionType

            item.Details = varDetails

            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Update(ByVal varEventId As String, ByVal varEventTimeUtc As DateTime, ByVal varEventTime As DateTime, ByVal varEventType As String, ByVal varEventSequence As Decimal, ByVal varEventOccurrence As Decimal, ByVal varEventCode As Integer, ByVal varEventDetailCode As Integer, ByVal varMessage As String, ByVal varApplicationPath As String, ByVal varApplicationVirtualPath As String, ByVal varMachineName As String, ByVal varRequestUrl As String, ByVal varExceptionType As String, ByVal varDetails As String)
            Dim item As AspnetWebEventEvents = New AspnetWebEventEvents()

            item.EventId = varEventId

            item.EventTimeUtc = varEventTimeUtc

            item.EventTime = varEventTime

            item.EventType = varEventType

            item.EventSequence = varEventSequence

            item.EventOccurrence = varEventOccurrence

            item.EventCode = varEventCode

            item.EventDetailCode = varEventDetailCode

            item.Message = varMessage

            item.ApplicationPath = varApplicationPath

            item.ApplicationVirtualPath = varApplicationVirtualPath

            item.MachineName = varMachineName

            item.RequestUrl = varRequestUrl

            item.ExceptionType = varExceptionType

            item.Details = varDetails

            item.IsNew = False
            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
#End Region
#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared EventId As String = "EventId"

            Public Shared EventTimeUtc As String = "EventTimeUtc"

            Public Shared EventTime As String = "EventTime"

            Public Shared EventType As String = "EventType"

            Public Shared EventSequence As String = "EventSequence"

            Public Shared EventOccurrence As String = "EventOccurrence"

            Public Shared EventCode As String = "EventCode"

            Public Shared EventDetailCode As String = "EventDetailCode"

            Public Shared Message As String = "Message"

            Public Shared ApplicationPath As String = "ApplicationPath"

            Public Shared ApplicationVirtualPath As String = "ApplicationVirtualPath"

            Public Shared MachineName As String = "MachineName"

            Public Shared RequestUrl As String = "RequestUrl"

            Public Shared ExceptionType As String = "ExceptionType"

            Public Shared Details As String = "Details"

        End Structure
#End Region
    End Class
End Namespace
