Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for Attendance
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class AttendanceController

        ' Preload our schema..
        Dim thisSchemaLoad As Attendance = New Attendance()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As AttendanceCollection

            Dim coll As AttendanceCollection = New AttendanceCollection()
            Dim qry As Query = New Query(Attendance.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Eventid As Object) As AttendanceCollection

            Dim coll As AttendanceCollection = New AttendanceCollection().Where("eventid", Eventid).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As AttendanceCollection

            Dim coll As AttendanceCollection = New AttendanceCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Eventid As Object) As Boolean

            Return (Attendance.Delete(Eventid) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Eventid As Object) As Boolean

            Return (Attendance.Destroy(Eventid) = 1)

        End Function


        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Eventid As Integer, ByVal Member As Guid) As Boolean
            Dim qry As Query = New Query(Attendance.Schema)
            qry.QueryType = QueryType.Delete
            qry.AddWhere("Eventid", Eventid).AND("Member", Member)
            qry.Execute()
            Return True
        End Function



        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal Eventid As Integer, ByVal Member As Guid, ByVal Numofguest As Integer)

            Dim item As Attendance = New Attendance()

            item.Eventid = Eventid

            item.Member = Member

            item.Numofguest = Numofguest


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Eventid As Integer, ByVal Member As Guid, ByVal Numofguest As Integer)

            Dim item As Attendance = New Attendance()

            item.Eventid = Eventid

            item.Member = Member

            item.Numofguest = Numofguest

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
