Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for BlogComments
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class BlogCommentController

        ' Preload our schema..
        Dim thisSchemaLoad As BlogComment = New BlogComment()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As BlogCommentCollection

            Dim coll As BlogCommentCollection = New BlogCommentCollection()
            Dim qry As Query = New Query(BlogComment.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Commentid As Object) As BlogCommentCollection

            Dim coll As BlogCommentCollection = New BlogCommentCollection().Where("commentid", Commentid).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As BlogCommentCollection

            Dim coll As BlogCommentCollection = New BlogCommentCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Commentid As Object) As Boolean

            Return (BlogComment.Delete(Commentid) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Commentid As Object) As Boolean

            Return (BlogComment.Destroy(Commentid) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal Postid As Integer, ByVal Name As String, ByVal Email As String, ByVal Comment As String)

            Dim item As BlogComment = New BlogComment()

            item.Postid = Postid

            item.Name = Name

            item.Email = Email

            item.Comment = Comment


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Commentid As Integer, ByVal Postid As Integer, ByVal Name As String, ByVal Email As String, ByVal Comment As String)

            Dim item As BlogComment = New BlogComment()

            item.Commentid = Commentid

            item.Postid = Postid

            item.Name = Name

            item.Email = Email

            item.Comment = Comment

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
