Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the Downloads class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class DownloadsCollection
        Inherits ActiveList(Of Downloads, DownloadsCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is an ActiveRecord class which wraps the Downloads table.
    ''' </summary>
    <Serializable()> _
    Partial Public Class Downloads
        Inherits ActiveRecord(Of Downloads)
#Region ".ctors and Default Settings"

        Public Sub New()
            SetSQLProps()
            InitSetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub
        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByKey(keyID)
        End Sub
        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByParam(columnName, columnValue)
        End Sub
        Private Sub InitSetDefaults()
            SetDefaults()
        End Sub

        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region

#Region "Schema and Query Accessor"

        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If BaseSchema Is Nothing Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property
        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("Downloads", TableType.Table, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"
                'columns


                Dim colvarId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarId.ColumnName = "id"
                colvarId.DataType = DbType.Int32
                colvarId.MaxLength = 0
                colvarId.AutoIncrement = True
                colvarId.IsNullable = False
                colvarId.IsPrimaryKey = True
                colvarId.IsForeignKey = False
                colvarId.IsReadOnly = False


                schema.Columns.Add(colvarId)

                Dim colvarUrl As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarUrl.ColumnName = "URL"
                colvarUrl.DataType = DbType.String
                colvarUrl.MaxLength = 2147483647
                colvarUrl.AutoIncrement = False
                colvarUrl.IsNullable = False
                colvarUrl.IsPrimaryKey = False
                colvarUrl.IsForeignKey = False
                colvarUrl.IsReadOnly = False


                schema.Columns.Add(colvarUrl)

                Dim colvarTitle As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarTitle.ColumnName = "Title"
                colvarTitle.DataType = DbType.String
                colvarTitle.MaxLength = 2147483647
                colvarTitle.AutoIncrement = False
                colvarTitle.IsNullable = False
                colvarTitle.IsPrimaryKey = False
                colvarTitle.IsForeignKey = False
                colvarTitle.IsReadOnly = False


                schema.Columns.Add(colvarTitle)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("Downloads", schema)
            End If
        End Sub
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function

#End Region

#Region "Props"


        <XmlAttribute("Id")> _
        Public Property Id() As Integer
            Get
                Return GetColumnValue(Of Integer)("id")
            End Get

            Set(ByVal value As Integer)
                SetColumnValue("id", Value)
            End Set
        End Property



        <XmlAttribute("Url")> _
        Public Property Url() As String
            Get
                Return GetColumnValue(Of String)("URL")
            End Get

            Set(ByVal value As String)
                SetColumnValue("URL", Value)
            End Set
        End Property



        <XmlAttribute("Title")> _
        Public Property Title() As String
            Get
                Return GetColumnValue(Of String)("Title")
            End Get

            Set(ByVal value As String)
                SetColumnValue("Title", Value)
            End Set
        End Property




#End Region










        'no foreign key tables defined (0)



        'no ManyToMany tables defined (0)


#Region "ObjectDataSource support"

        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Insert(ByVal varUrl As String, ByVal varTitle As String)
            Dim item As Downloads = New Downloads()

            item.Url = varUrl

            item.Title = varTitle

            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Update(ByVal varId As Integer, ByVal varUrl As String, ByVal varTitle As String)
            Dim item As Downloads = New Downloads()

            item.Id = varId

            item.Url = varUrl

            item.Title = varTitle

            item.IsNew = False
            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
#End Region
#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared Id As String = "id"

            Public Shared Url As String = "URL"

            Public Shared Title As String = "Title"

        End Structure
#End Region
    End Class
End Namespace
