Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the DownloadsInNews class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class DownloadsInNewsCollection
        Inherits ActiveList(Of DownloadsInNews, DownloadsInNewsCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is an ActiveRecord class which wraps the DownloadsInNews table.
    ''' </summary>
    <Serializable()> _
    Partial Public Class DownloadsInNews
        Inherits ActiveRecord(Of DownloadsInNews)
#Region ".ctors and Default Settings"

        Public Sub New()
            SetSQLProps()
            InitSetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub
        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByKey(keyID)
        End Sub
        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByParam(columnName, columnValue)
        End Sub
        Private Sub InitSetDefaults()
            SetDefaults()
        End Sub

        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region

#Region "Schema and Query Accessor"

        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If BaseSchema Is Nothing Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property
        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("DownloadsInNews", TableType.Table, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"
                'columns


                Dim colvarId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarId.ColumnName = "id"
                colvarId.DataType = DbType.Int32
                colvarId.MaxLength = 0
                colvarId.AutoIncrement = True
                colvarId.IsNullable = False
                colvarId.IsPrimaryKey = True
                colvarId.IsForeignKey = False
                colvarId.IsReadOnly = False


                schema.Columns.Add(colvarId)

                Dim colvarNewsid As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarNewsid.ColumnName = "newsid"
                colvarNewsid.DataType = DbType.Int32
                colvarNewsid.MaxLength = 0
                colvarNewsid.AutoIncrement = False
                colvarNewsid.IsNullable = False
                colvarNewsid.IsPrimaryKey = False
                colvarNewsid.IsForeignKey = False
                colvarNewsid.IsReadOnly = False


                schema.Columns.Add(colvarNewsid)

                Dim colvarDownloadid As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarDownloadid.ColumnName = "downloadid"
                colvarDownloadid.DataType = DbType.Int32
                colvarDownloadid.MaxLength = 0
                colvarDownloadid.AutoIncrement = False
                colvarDownloadid.IsNullable = False
                colvarDownloadid.IsPrimaryKey = False
                colvarDownloadid.IsForeignKey = False
                colvarDownloadid.IsReadOnly = False


                schema.Columns.Add(colvarDownloadid)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("DownloadsInNews", schema)
            End If
        End Sub
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function

#End Region

#Region "Props"


        <XmlAttribute("Id")> _
        Public Property Id() As Integer
            Get
                Return GetColumnValue(Of Integer)("id")
            End Get

            Set(ByVal value As Integer)
                SetColumnValue("id", Value)
            End Set
        End Property



        <XmlAttribute("Newsid")> _
        Public Property Newsid() As Integer
            Get
                Return GetColumnValue(Of Integer)("newsid")
            End Get

            Set(ByVal value As Integer)
                SetColumnValue("newsid", Value)
            End Set
        End Property



        <XmlAttribute("Downloadid")> _
        Public Property Downloadid() As Integer
            Get
                Return GetColumnValue(Of Integer)("downloadid")
            End Get

            Set(ByVal value As Integer)
                SetColumnValue("downloadid", Value)
            End Set
        End Property




#End Region










        'no foreign key tables defined (0)



        'no ManyToMany tables defined (0)


#Region "ObjectDataSource support"

        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Insert(ByVal varNewsid As Integer, ByVal varDownloadid As Integer)
            Dim item As DownloadsInNews = New DownloadsInNews()

            item.Newsid = varNewsid

            item.Downloadid = varDownloadid

            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Update(ByVal varId As Integer, ByVal varNewsid As Integer, ByVal varDownloadid As Integer)
            Dim item As DownloadsInNews = New DownloadsInNews()

            item.Id = varId

            item.Newsid = varNewsid

            item.Downloadid = varDownloadid

            item.IsNew = False
            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
#End Region
#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared Id As String = "id"

            Public Shared Newsid As String = "newsid"

            Public Shared Downloadid As String = "downloadid"

        End Structure
#End Region
    End Class
End Namespace
