Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the HitCounter class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class HitCounterCollection
        Inherits ActiveList(Of HitCounter, HitCounterCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is an ActiveRecord class which wraps the HitCounter table.
    ''' </summary>
    <Serializable()> _
    Partial Public Class HitCounter
        Inherits ActiveRecord(Of HitCounter)
#Region ".ctors and Default Settings"

        Public Sub New()
            SetSQLProps()
            InitSetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub
        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByKey(keyID)
        End Sub
        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByParam(columnName, columnValue)
        End Sub
        Private Sub InitSetDefaults()
            SetDefaults()
        End Sub

        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region

#Region "Schema and Query Accessor"

        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If BaseSchema Is Nothing Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property
        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("HitCounter", TableType.Table, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"
                'columns


                Dim colvarId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarId.ColumnName = "ID"
                colvarId.DataType = DbType.Int32
                colvarId.MaxLength = 0
                colvarId.AutoIncrement = True
                colvarId.IsNullable = False
                colvarId.IsPrimaryKey = True
                colvarId.IsForeignKey = False
                colvarId.IsReadOnly = False


                schema.Columns.Add(colvarId)

                Dim colvarDteTime As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarDteTime.ColumnName = "DteTime"
                colvarDteTime.DataType = DbType.DateTime
                colvarDteTime.MaxLength = 0
                colvarDteTime.AutoIncrement = False
                colvarDteTime.IsNullable = False
                colvarDteTime.IsPrimaryKey = False
                colvarDteTime.IsForeignKey = False
                colvarDteTime.IsReadOnly = False


                schema.Columns.Add(colvarDteTime)

                Dim colvarPage As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarPage.ColumnName = "Page"
                colvarPage.DataType = DbType.String
                colvarPage.MaxLength = -1
                colvarPage.AutoIncrement = False
                colvarPage.IsNullable = False
                colvarPage.IsPrimaryKey = False
                colvarPage.IsForeignKey = False
                colvarPage.IsReadOnly = False


                schema.Columns.Add(colvarPage)

                Dim colvarUsername As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarUsername.ColumnName = "Username"
                colvarUsername.DataType = DbType.String
                colvarUsername.MaxLength = 50
                colvarUsername.AutoIncrement = False
                colvarUsername.IsNullable = True
                colvarUsername.IsPrimaryKey = False
                colvarUsername.IsForeignKey = False
                colvarUsername.IsReadOnly = False


                schema.Columns.Add(colvarUsername)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("HitCounter", schema)
            End If
        End Sub
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function

#End Region

#Region "Props"


        <XmlAttribute("Id")> _
        Public Property Id() As Integer
            Get
                Return GetColumnValue(Of Integer)("ID")
            End Get

            Set(ByVal value As Integer)
                SetColumnValue("ID", Value)
            End Set
        End Property



        <XmlAttribute("DteTime")> _
        Public Property DteTime() As DateTime
            Get
                Return GetColumnValue(Of DateTime)("DteTime")
            End Get

            Set(ByVal value As DateTime)
                SetColumnValue("DteTime", Value)
            End Set
        End Property



        <XmlAttribute("Page")> _
        Public Property Page() As String
            Get
                Return GetColumnValue(Of String)("Page")
            End Get

            Set(ByVal value As String)
                SetColumnValue("Page", Value)
            End Set
        End Property



        <XmlAttribute("Username")> _
        Public Property Username() As String
            Get
                Return GetColumnValue(Of String)("Username")
            End Get

            Set(ByVal value As String)
                SetColumnValue("Username", Value)
            End Set
        End Property




#End Region










        'no foreign key tables defined (0)



        'no ManyToMany tables defined (0)


#Region "ObjectDataSource support"

        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Insert(ByVal varDteTime As DateTime, ByVal varPage As String, ByVal varUsername As String)
            Dim item As HitCounter = New HitCounter()

            item.DteTime = varDteTime

            item.Page = varPage

            item.Username = varUsername

            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Update(ByVal varId As Integer, ByVal varDteTime As DateTime, ByVal varPage As String, ByVal varUsername As String)
            Dim item As HitCounter = New HitCounter()

            item.Id = varId

            item.DteTime = varDteTime

            item.Page = varPage

            item.Username = varUsername

            item.IsNew = False
            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
#End Region
#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared Id As String = "ID"

            Public Shared DteTime As String = "DteTime"

            Public Shared Page As String = "Page"

            Public Shared Username As String = "Username"

        End Structure
#End Region
    End Class
End Namespace
