Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for HitCounter
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class HitCounterController

        ' Preload our schema..
        Dim thisSchemaLoad As HitCounter = New HitCounter()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As HitCounterCollection

            Dim coll As HitCounterCollection = New HitCounterCollection()
            Dim qry As Query = New Query(HitCounter.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Id As Object) As HitCounterCollection

            Dim coll As HitCounterCollection = New HitCounterCollection().Where("ID", Id).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As HitCounterCollection

            Dim coll As HitCounterCollection = New HitCounterCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Id As Object) As Boolean

            Return (HitCounter.Delete(Id) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Id As Object) As Boolean

            Return (HitCounter.Destroy(Id) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal DteTime As DateTime, ByVal Page As String, ByVal Username As String)

            Dim item As HitCounter = New HitCounter()

            item.DteTime = DteTime

            item.Page = Page

            item.Username = Username


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Id As Integer, ByVal DteTime As DateTime, ByVal Page As String, ByVal Username As String)

            Dim item As HitCounter = New HitCounter()

            item.Id = Id

            item.DteTime = DteTime

            item.Page = Page

            item.Username = Username

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
