Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for image
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class ImageController

        ' Preload our schema..
        Dim thisSchemaLoad As Image = New Image()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As ImageCollection

            Dim coll As ImageCollection = New ImageCollection()
            Dim qry As Query = New Query(Image.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Id As Object) As ImageCollection

            Dim coll As ImageCollection = New ImageCollection().Where("id", Id).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As ImageCollection

            Dim coll As ImageCollection = New ImageCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Id As Object) As Boolean

            Return (Image.Delete(Id) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Id As Object) As Boolean

            Return (Image.Destroy(Id) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal Title As String, ByVal ImageFileName As String, ByVal Album As Integer, ByVal Notes As String)

            Dim item As Image = New Image()

            item.Title = Title

            item.ImageFileName = ImageFileName

            item.Album = Album

            item.Notes = Notes


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Id As Integer, ByVal Title As String, ByVal ImageFileName As String, ByVal Album As Integer, ByVal Notes As String)

            Dim item As Image = New Image()

            item.Id = Id

            item.Title = Title

            item.ImageFileName = ImageFileName

            item.Album = Album

            item.Notes = Notes

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
