Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the Link class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class LinkCollection
        Inherits ActiveList(Of Link, LinkCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is an ActiveRecord class which wraps the Links table.
    ''' </summary>
    <Serializable()> _
    Partial Public Class Link
        Inherits ActiveRecord(Of Link)
#Region ".ctors and Default Settings"

        Public Sub New()
            SetSQLProps()
            InitSetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub
        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByKey(keyID)
        End Sub
        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByParam(columnName, columnValue)
        End Sub
        Private Sub InitSetDefaults()
            SetDefaults()
        End Sub

        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region

#Region "Schema and Query Accessor"

        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If BaseSchema Is Nothing Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property
        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("Links", TableType.Table, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"
                'columns


                Dim colvarLinkid As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarLinkid.ColumnName = "linkid"
                colvarLinkid.DataType = DbType.Int32
                colvarLinkid.MaxLength = 0
                colvarLinkid.AutoIncrement = True
                colvarLinkid.IsNullable = False
                colvarLinkid.IsPrimaryKey = True
                colvarLinkid.IsForeignKey = False
                colvarLinkid.IsReadOnly = False


                schema.Columns.Add(colvarLinkid)

                Dim colvarName As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarName.ColumnName = "Name"
                colvarName.DataType = DbType.String
                colvarName.MaxLength = 2147483647
                colvarName.AutoIncrement = False
                colvarName.IsNullable = False
                colvarName.IsPrimaryKey = False
                colvarName.IsForeignKey = False
                colvarName.IsReadOnly = False


                schema.Columns.Add(colvarName)

                Dim colvarUrl As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarUrl.ColumnName = "URL"
                colvarUrl.DataType = DbType.String
                colvarUrl.MaxLength = 2147483647
                colvarUrl.AutoIncrement = False
                colvarUrl.IsNullable = False
                colvarUrl.IsPrimaryKey = False
                colvarUrl.IsForeignKey = False
                colvarUrl.IsReadOnly = False


                schema.Columns.Add(colvarUrl)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("Links", schema)
            End If
        End Sub
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function

#End Region

#Region "Props"


        <XmlAttribute("Linkid")> _
        Public Property Linkid() As Integer
            Get
                Return GetColumnValue(Of Integer)("linkid")
            End Get

            Set(ByVal value As Integer)
                SetColumnValue("linkid", Value)
            End Set
        End Property



        <XmlAttribute("Name")> _
        Public Property Name() As String
            Get
                Return GetColumnValue(Of String)("Name")
            End Get

            Set(ByVal value As String)
                SetColumnValue("Name", Value)
            End Set
        End Property



        <XmlAttribute("Url")> _
        Public Property Url() As String
            Get
                Return GetColumnValue(Of String)("URL")
            End Get

            Set(ByVal value As String)
                SetColumnValue("URL", Value)
            End Set
        End Property




#End Region










        'no foreign key tables defined (0)



        'no ManyToMany tables defined (0)


#Region "ObjectDataSource support"

        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Insert(ByVal varName As String, ByVal varUrl As String)
            Dim item As Link = New Link()

            item.Name = varName

            item.Url = varUrl

            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Update(ByVal varLinkid As Integer, ByVal varName As String, ByVal varUrl As String)
            Dim item As Link = New Link()

            item.Linkid = varLinkid

            item.Name = varName

            item.Url = varUrl

            item.IsNew = False
            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
#End Region
#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared Linkid As String = "linkid"

            Public Shared Name As String = "Name"

            Public Shared Url As String = "URL"

        End Structure
#End Region
    End Class
End Namespace
