Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for Links
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class LinksController

        ' Preload our schema..
        Dim thisSchemaLoad As Links = New Links()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As LinksCollection

            Dim coll As LinksCollection = New LinksCollection()
            Dim qry As Query = New Query(Links.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Linkid As Object) As LinksCollection

            Dim coll As LinksCollection = New LinksCollection().Where("linkid", Linkid).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As LinksCollection

            Dim coll As LinksCollection = New LinksCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Linkid As Object) As Boolean

            Return (Links.Delete(Linkid) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Linkid As Object) As Boolean

            Return (Links.Destroy(Linkid) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal Name As String, ByVal Url As String)

            Dim item As Links = New Links()

            item.Name = Name

            item.Url = Url


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Linkid As Integer, ByVal Name As String, ByVal Url As String)

            Dim item As Links = New Links()

            item.Linkid = Linkid

            item.Name = Name

            item.Url = Url

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
