Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for Locations
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class LocationController

        ' Preload our schema..
        Dim thisSchemaLoad As Location = New Location()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As LocationCollection

            Dim coll As LocationCollection = New LocationCollection()
            Dim qry As Query = New Query(Location.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Id As Object) As LocationCollection

            Dim coll As LocationCollection = New LocationCollection().Where("id", Id).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As LocationCollection

            Dim coll As LocationCollection = New LocationCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Id As Object) As Boolean

            Return (Location.Delete(Id) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Id As Object) As Boolean

            Return (Location.Destroy(Id) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal Title As String, ByVal Description As String, ByVal LinkURL As String, ByVal Photo As Integer, ByVal Directions As String, ByVal Address As String)

            Dim item As Location = New Location()

            item.Title = Title

            item.Description = Description

            item.LinkURL = LinkURL

            item.Photo = Photo

            item.Directions = Directions

            item.Address = Address


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Id As Integer, ByVal Title As String, ByVal Description As String, ByVal LinkURL As String, ByVal Photo As Integer, ByVal Directions As String, ByVal Address As String)

            Dim item As Location = New Location()

            item.Id = Id

            item.Title = Title

            item.Description = Description

            item.LinkURL = LinkURL

            item.Photo = Photo

            item.Directions = Directions

            item.Address = Address

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
