Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the Locations class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class LocationsCollection
        Inherits ActiveList(Of Locations, LocationsCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is an ActiveRecord class which wraps the Locations table.
    ''' </summary>
    <Serializable()> _
    Partial Public Class Locations
        Inherits ActiveRecord(Of Locations)
#Region ".ctors and Default Settings"

        Public Sub New()
            SetSQLProps()
            InitSetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub
        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByKey(keyID)
        End Sub
        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByParam(columnName, columnValue)
        End Sub
        Private Sub InitSetDefaults()
            SetDefaults()
        End Sub

        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region

#Region "Schema and Query Accessor"

        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If BaseSchema Is Nothing Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property
        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("Locations", TableType.Table, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"
                'columns


                Dim colvarId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarId.ColumnName = "id"
                colvarId.DataType = DbType.Int32
                colvarId.MaxLength = 0
                colvarId.AutoIncrement = True
                colvarId.IsNullable = False
                colvarId.IsPrimaryKey = True
                colvarId.IsForeignKey = False
                colvarId.IsReadOnly = False


                schema.Columns.Add(colvarId)

                Dim colvarTitle As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarTitle.ColumnName = "title"
                colvarTitle.DataType = DbType.String
                colvarTitle.MaxLength = 500
                colvarTitle.AutoIncrement = False
                colvarTitle.IsNullable = False
                colvarTitle.IsPrimaryKey = False
                colvarTitle.IsForeignKey = False
                colvarTitle.IsReadOnly = False


                schema.Columns.Add(colvarTitle)

                Dim colvarDescription As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarDescription.ColumnName = "description"
                colvarDescription.DataType = DbType.String
                colvarDescription.MaxLength = 800
                colvarDescription.AutoIncrement = False
                colvarDescription.IsNullable = True
                colvarDescription.IsPrimaryKey = False
                colvarDescription.IsForeignKey = False
                colvarDescription.IsReadOnly = False


                schema.Columns.Add(colvarDescription)

                Dim colvarLinkURL As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarLinkURL.ColumnName = "linkURL"
                colvarLinkURL.DataType = DbType.String
                colvarLinkURL.MaxLength = 500
                colvarLinkURL.AutoIncrement = False
                colvarLinkURL.IsNullable = True
                colvarLinkURL.IsPrimaryKey = False
                colvarLinkURL.IsForeignKey = False
                colvarLinkURL.IsReadOnly = False


                schema.Columns.Add(colvarLinkURL)

                Dim colvarPhoto As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarPhoto.ColumnName = "photo"
                colvarPhoto.DataType = DbType.Int32
                colvarPhoto.MaxLength = 0
                colvarPhoto.AutoIncrement = False
                colvarPhoto.IsNullable = False
                colvarPhoto.IsPrimaryKey = False
                colvarPhoto.IsForeignKey = False
                colvarPhoto.IsReadOnly = False


                schema.Columns.Add(colvarPhoto)

                Dim colvarDirections As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarDirections.ColumnName = "directions"
                colvarDirections.DataType = DbType.String
                colvarDirections.MaxLength = 800
                colvarDirections.AutoIncrement = False
                colvarDirections.IsNullable = True
                colvarDirections.IsPrimaryKey = False
                colvarDirections.IsForeignKey = False
                colvarDirections.IsReadOnly = False


                schema.Columns.Add(colvarDirections)

                Dim colvarAddress As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarAddress.ColumnName = "address"
                colvarAddress.DataType = DbType.String
                colvarAddress.MaxLength = 300
                colvarAddress.AutoIncrement = False
                colvarAddress.IsNullable = True
                colvarAddress.IsPrimaryKey = False
                colvarAddress.IsForeignKey = False
                colvarAddress.IsReadOnly = False


                schema.Columns.Add(colvarAddress)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("Locations", schema)
            End If
        End Sub
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function

#End Region

#Region "Props"


        <XmlAttribute("Id")> _
        Public Property Id() As Integer
            Get
                Return GetColumnValue(Of Integer)("id")
            End Get

            Set(ByVal value As Integer)
                SetColumnValue("id", Value)
            End Set
        End Property



        <XmlAttribute("Title")> _
        Public Property Title() As String
            Get
                Return GetColumnValue(Of String)("title")
            End Get

            Set(ByVal value As String)
                SetColumnValue("title", Value)
            End Set
        End Property



        <XmlAttribute("Description")> _
        Public Property Description() As String
            Get
                Return GetColumnValue(Of String)("description")
            End Get

            Set(ByVal value As String)
                SetColumnValue("description", Value)
            End Set
        End Property



        <XmlAttribute("LinkURL")> _
        Public Property LinkURL() As String
            Get
                Return GetColumnValue(Of String)("linkURL")
            End Get

            Set(ByVal value As String)
                SetColumnValue("linkURL", Value)
            End Set
        End Property



        <XmlAttribute("Photo")> _
        Public Property Photo() As Integer
            Get
                Return GetColumnValue(Of Integer)("photo")
            End Get

            Set(ByVal value As Integer)
                SetColumnValue("photo", Value)
            End Set
        End Property



        <XmlAttribute("Directions")> _
        Public Property Directions() As String
            Get
                Return GetColumnValue(Of String)("directions")
            End Get

            Set(ByVal value As String)
                SetColumnValue("directions", Value)
            End Set
        End Property



        <XmlAttribute("Address")> _
        Public Property Address() As String
            Get
                Return GetColumnValue(Of String)("address")
            End Get

            Set(ByVal value As String)
                SetColumnValue("address", Value)
            End Set
        End Property




#End Region










        'no foreign key tables defined (0)



        'no ManyToMany tables defined (0)


#Region "ObjectDataSource support"

        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Insert(ByVal varTitle As String, ByVal varDescription As String, ByVal varLinkURL As String, ByVal varPhoto As Integer, ByVal varDirections As String, ByVal varAddress As String)
            Dim item As Locations = New Locations()

            item.Title = varTitle

            item.Description = varDescription

            item.LinkURL = varLinkURL

            item.Photo = varPhoto

            item.Directions = varDirections

            item.Address = varAddress

            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Update(ByVal varId As Integer, ByVal varTitle As String, ByVal varDescription As String, ByVal varLinkURL As String, ByVal varPhoto As Integer, ByVal varDirections As String, ByVal varAddress As String)
            Dim item As Locations = New Locations()

            item.Id = varId

            item.Title = varTitle

            item.Description = varDescription

            item.LinkURL = varLinkURL

            item.Photo = varPhoto

            item.Directions = varDirections

            item.Address = varAddress

            item.IsNew = False
            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
#End Region
#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared Id As String = "id"

            Public Shared Title As String = "title"

            Public Shared Description As String = "description"

            Public Shared LinkURL As String = "linkURL"

            Public Shared Photo As String = "photo"

            Public Shared Directions As String = "directions"

            Public Shared Address As String = "address"

        End Structure
#End Region
    End Class
End Namespace
