Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for MemberInfo
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class MemberInfoController

        ' Preload our schema..
        Dim thisSchemaLoad As MemberInfo = New MemberInfo()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As MemberInfoCollection

            Dim coll As MemberInfoCollection = New MemberInfoCollection()
            Dim qry As Query = New Query(MemberInfo.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Memberid As Object) As MemberInfoCollection

            Dim coll As MemberInfoCollection = New MemberInfoCollection().Where("memberid", Memberid).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As MemberInfoCollection

            Dim coll As MemberInfoCollection = New MemberInfoCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Memberid As Object) As Boolean

            Return (MemberInfo.Delete(Memberid) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Memberid As Object) As Boolean

            Return (MemberInfo.Destroy(Memberid) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal Address As String, ByVal Phone As String, ByVal Firstname As String, ByVal Lastname As String, ByVal Avatar As Byte(), ByVal Memberid As Guid, ByVal Newsletter As Nullable(Of Boolean))

            Dim item As MemberInfo = New MemberInfo()

            item.Address = Address

            item.Phone = Phone

            item.Firstname = Firstname

            item.Lastname = Lastname

            item.Avatar = Avatar

            item.Memberid = Memberid

            item.Newsletter = Newsletter


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Address As String, ByVal Phone As String, ByVal Firstname As String, ByVal Lastname As String, ByVal Avatar As Byte(), ByVal Memberid As Guid, ByVal Newsletter As Nullable(Of Boolean))

            Dim item As MemberInfo = New MemberInfo()

            item.Address = Address

            item.Phone = Phone

            item.Firstname = Firstname

            item.Lastname = Lastname

            item.Avatar = Avatar

            item.Memberid = Memberid

            item.Newsletter = Newsletter

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
