Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the MemberProfile class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class MemberProfileCollection
        Inherits ActiveList(Of MemberProfile, MemberProfileCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is an ActiveRecord class which wraps the MemberProfile table.
    ''' </summary>
    <Serializable()> _
    Partial Public Class MemberProfile
        Inherits ActiveRecord(Of MemberProfile)
#Region ".ctors and Default Settings"

        Public Sub New()
            SetSQLProps()
            InitSetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub
        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByKey(keyID)
        End Sub
        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByParam(columnName, columnValue)
        End Sub
        Private Sub InitSetDefaults()
            SetDefaults()
        End Sub

        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region

#Region "Schema and Query Accessor"

        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If BaseSchema Is Nothing Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property
        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("MemberProfile", TableType.Table, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"
                'columns


                Dim colvarMemberid As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarMemberid.ColumnName = "memberid"
                colvarMemberid.DataType = DbType.Guid
                colvarMemberid.MaxLength = 0
                colvarMemberid.AutoIncrement = False
                colvarMemberid.IsNullable = False
                colvarMemberid.IsPrimaryKey = True
                colvarMemberid.IsForeignKey = False
                colvarMemberid.IsReadOnly = False


                schema.Columns.Add(colvarMemberid)

                Dim colvarNewmsgthreshold As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarNewmsgthreshold.ColumnName = "newmsgthreshold"
                colvarNewmsgthreshold.DataType = DbType.DateTime
                colvarNewmsgthreshold.MaxLength = 0
                colvarNewmsgthreshold.AutoIncrement = False
                colvarNewmsgthreshold.IsNullable = False
                colvarNewmsgthreshold.IsPrimaryKey = False
                colvarNewmsgthreshold.IsForeignKey = False
                colvarNewmsgthreshold.IsReadOnly = False

                colvarNewmsgthreshold.DefaultSetting = "('20000101')"


                schema.Columns.Add(colvarNewmsgthreshold)

                Dim colvarSignature As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarSignature.ColumnName = "signature"
                colvarSignature.DataType = DbType.String
                colvarSignature.MaxLength = 1024
                colvarSignature.AutoIncrement = False
                colvarSignature.IsNullable = False
                colvarSignature.IsPrimaryKey = False
                colvarSignature.IsForeignKey = False
                colvarSignature.IsReadOnly = False

                colvarSignature.DefaultSetting = "('')"


                schema.Columns.Add(colvarSignature)

                Dim colvarBio As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarBio.ColumnName = "bio"
                colvarBio.DataType = DbType.String
                colvarBio.MaxLength = 1024
                colvarBio.AutoIncrement = False
                colvarBio.IsNullable = False
                colvarBio.IsPrimaryKey = False
                colvarBio.IsForeignKey = False
                colvarBio.IsReadOnly = False

                colvarBio.DefaultSetting = "('')"


                schema.Columns.Add(colvarBio)

                Dim colvarSortdesc As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarSortdesc.ColumnName = "sortdesc"
                colvarSortdesc.DataType = DbType.Boolean
                colvarSortdesc.MaxLength = 0
                colvarSortdesc.AutoIncrement = False
                colvarSortdesc.IsNullable = False
                colvarSortdesc.IsPrimaryKey = False
                colvarSortdesc.IsForeignKey = False
                colvarSortdesc.IsReadOnly = False

                colvarSortdesc.DefaultSetting = "((0))"


                schema.Columns.Add(colvarSortdesc)

                Dim colvarMsgsperpage As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarMsgsperpage.ColumnName = "msgsperpage"
                colvarMsgsperpage.DataType = DbType.Int32
                colvarMsgsperpage.MaxLength = 0
                colvarMsgsperpage.AutoIncrement = False
                colvarMsgsperpage.IsNullable = False
                colvarMsgsperpage.IsPrimaryKey = False
                colvarMsgsperpage.IsForeignKey = False
                colvarMsgsperpage.IsReadOnly = False

                colvarMsgsperpage.DefaultSetting = "((10))"


                schema.Columns.Add(colvarMsgsperpage)

                Dim colvarShowavatars As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarShowavatars.ColumnName = "showavatars"
                colvarShowavatars.DataType = DbType.Boolean
                colvarShowavatars.MaxLength = 0
                colvarShowavatars.AutoIncrement = False
                colvarShowavatars.IsNullable = False
                colvarShowavatars.IsPrimaryKey = False
                colvarShowavatars.IsForeignKey = False
                colvarShowavatars.IsReadOnly = False

                colvarShowavatars.DefaultSetting = "((1))"


                schema.Columns.Add(colvarShowavatars)

                Dim colvarShowsignatures As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarShowsignatures.ColumnName = "showsignatures"
                colvarShowsignatures.DataType = DbType.Boolean
                colvarShowsignatures.MaxLength = 0
                colvarShowsignatures.AutoIncrement = False
                colvarShowsignatures.IsNullable = False
                colvarShowsignatures.IsPrimaryKey = False
                colvarShowsignatures.IsForeignKey = False
                colvarShowsignatures.IsReadOnly = False

                colvarShowsignatures.DefaultSetting = "((1))"


                schema.Columns.Add(colvarShowsignatures)

                Dim colvarSendwatchemails As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarSendwatchemails.ColumnName = "sendwatchemails"
                colvarSendwatchemails.DataType = DbType.Boolean
                colvarSendwatchemails.MaxLength = 0
                colvarSendwatchemails.AutoIncrement = False
                colvarSendwatchemails.IsNullable = False
                colvarSendwatchemails.IsPrimaryKey = False
                colvarSendwatchemails.IsForeignKey = False
                colvarSendwatchemails.IsReadOnly = False

                colvarSendwatchemails.DefaultSetting = "((1))"


                schema.Columns.Add(colvarSendwatchemails)

                Dim colvarShowemail As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarShowemail.ColumnName = "showemail"
                colvarShowemail.DataType = DbType.Boolean
                colvarShowemail.MaxLength = 0
                colvarShowemail.AutoIncrement = False
                colvarShowemail.IsNullable = False
                colvarShowemail.IsPrimaryKey = False
                colvarShowemail.IsForeignKey = False
                colvarShowemail.IsReadOnly = False

                colvarShowemail.DefaultSetting = "((0))"


                schema.Columns.Add(colvarShowemail)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("MemberProfile", schema)
            End If
        End Sub
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function

#End Region

#Region "Props"


        <XmlAttribute("Memberid")> _
        Public Property Memberid() As Guid
            Get
                Return GetColumnValue(Of Guid)("memberid")
            End Get

            Set(ByVal value As Guid)
                SetColumnValue("memberid", Value)
            End Set
        End Property



        <XmlAttribute("Newmsgthreshold")> _
        Public Property Newmsgthreshold() As DateTime
            Get
                Return GetColumnValue(Of DateTime)("newmsgthreshold")
            End Get

            Set(ByVal value As DateTime)
                SetColumnValue("newmsgthreshold", Value)
            End Set
        End Property



        <XmlAttribute("Signature")> _
        Public Property Signature() As String
            Get
                Return GetColumnValue(Of String)("signature")
            End Get

            Set(ByVal value As String)
                SetColumnValue("signature", Value)
            End Set
        End Property



        <XmlAttribute("Bio")> _
        Public Property Bio() As String
            Get
                Return GetColumnValue(Of String)("bio")
            End Get

            Set(ByVal value As String)
                SetColumnValue("bio", Value)
            End Set
        End Property



        <XmlAttribute("Sortdesc")> _
        Public Property Sortdesc() As Boolean
            Get
                Return GetColumnValue(Of Boolean)("sortdesc")
            End Get

            Set(ByVal value As Boolean)
                SetColumnValue("sortdesc", Value)
            End Set
        End Property



        <XmlAttribute("Msgsperpage")> _
        Public Property Msgsperpage() As Integer
            Get
                Return GetColumnValue(Of Integer)("msgsperpage")
            End Get

            Set(ByVal value As Integer)
                SetColumnValue("msgsperpage", Value)
            End Set
        End Property



        <XmlAttribute("Showavatars")> _
        Public Property Showavatars() As Boolean
            Get
                Return GetColumnValue(Of Boolean)("showavatars")
            End Get

            Set(ByVal value As Boolean)
                SetColumnValue("showavatars", Value)
            End Set
        End Property



        <XmlAttribute("Showsignatures")> _
        Public Property Showsignatures() As Boolean
            Get
                Return GetColumnValue(Of Boolean)("showsignatures")
            End Get

            Set(ByVal value As Boolean)
                SetColumnValue("showsignatures", Value)
            End Set
        End Property



        <XmlAttribute("Sendwatchemails")> _
        Public Property Sendwatchemails() As Boolean
            Get
                Return GetColumnValue(Of Boolean)("sendwatchemails")
            End Get

            Set(ByVal value As Boolean)
                SetColumnValue("sendwatchemails", Value)
            End Set
        End Property



        <XmlAttribute("Showemail")> _
        Public Property Showemail() As Boolean
            Get
                Return GetColumnValue(Of Boolean)("showemail")
            End Get

            Set(ByVal value As Boolean)
                SetColumnValue("showemail", Value)
            End Set
        End Property




#End Region










        'no foreign key tables defined (0)



        'no ManyToMany tables defined (0)


#Region "ObjectDataSource support"

        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Insert(ByVal varMemberid As Guid, ByVal varNewmsgthreshold As DateTime, ByVal varSignature As String, ByVal varBio As String, ByVal varSortdesc As Boolean, ByVal varMsgsperpage As Integer, ByVal varShowavatars As Boolean, ByVal varShowsignatures As Boolean, ByVal varSendwatchemails As Boolean, ByVal varShowemail As Boolean)
            Dim item As MemberProfile = New MemberProfile()

            item.Memberid = varMemberid

            item.Newmsgthreshold = varNewmsgthreshold

            item.Signature = varSignature

            item.Bio = varBio

            item.Sortdesc = varSortdesc

            item.Msgsperpage = varMsgsperpage

            item.Showavatars = varShowavatars

            item.Showsignatures = varShowsignatures

            item.Sendwatchemails = varSendwatchemails

            item.Showemail = varShowemail

            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Update(ByVal varMemberid As Guid, ByVal varNewmsgthreshold As DateTime, ByVal varSignature As String, ByVal varBio As String, ByVal varSortdesc As Boolean, ByVal varMsgsperpage As Integer, ByVal varShowavatars As Boolean, ByVal varShowsignatures As Boolean, ByVal varSendwatchemails As Boolean, ByVal varShowemail As Boolean)
            Dim item As MemberProfile = New MemberProfile()

            item.Memberid = varMemberid

            item.Newmsgthreshold = varNewmsgthreshold

            item.Signature = varSignature

            item.Bio = varBio

            item.Sortdesc = varSortdesc

            item.Msgsperpage = varMsgsperpage

            item.Showavatars = varShowavatars

            item.Showsignatures = varShowsignatures

            item.Sendwatchemails = varSendwatchemails

            item.Showemail = varShowemail

            item.IsNew = False
            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
#End Region
#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared Memberid As String = "memberid"

            Public Shared Newmsgthreshold As String = "newmsgthreshold"

            Public Shared Signature As String = "signature"

            Public Shared Bio As String = "bio"

            Public Shared Sortdesc As String = "sortdesc"

            Public Shared Msgsperpage As String = "msgsperpage"

            Public Shared Showavatars As String = "showavatars"

            Public Shared Showsignatures As String = "showsignatures"

            Public Shared Sendwatchemails As String = "sendwatchemails"

            Public Shared Showemail As String = "showemail"

        End Structure
#End Region
    End Class
End Namespace
