Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for MembersThreads
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class MembersThreadController

        ' Preload our schema..
        Dim thisSchemaLoad As MembersThread = New MembersThread()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As MembersThreadCollection

            Dim coll As MembersThreadCollection = New MembersThreadCollection()
            Dim qry As Query = New Query(MembersThread.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Memberid As Object) As MembersThreadCollection

            Dim coll As MembersThreadCollection = New MembersThreadCollection().Where("memberid", Memberid).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As MembersThreadCollection

            Dim coll As MembersThreadCollection = New MembersThreadCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Memberid As Object) As Boolean

            Return (MembersThread.Delete(Memberid) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Memberid As Object) As Boolean

            Return (MembersThread.Destroy(Memberid) = 1)

        End Function


        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Memberid As Guid, ByVal Threadid As Integer) As Boolean
            Dim qry As Query = New Query(MembersThread.Schema)
            qry.QueryType = QueryType.Delete
            qry.AddWhere("Memberid", Memberid).AND("Threadid", Threadid)
            qry.Execute()
            Return True
        End Function



        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal Memberid As Guid, ByVal Threadid As Integer, ByVal Lastread As DateTime, ByVal Watch As Boolean)

            Dim item As MembersThread = New MembersThread()

            item.Memberid = Memberid

            item.Threadid = Threadid

            item.Lastread = Lastread

            item.Watch = Watch


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Memberid As Guid, ByVal Threadid As Integer, ByVal Lastread As DateTime, ByVal Watch As Boolean)

            Dim item As MembersThread = New MembersThread()

            item.Memberid = Memberid

            item.Threadid = Threadid

            item.Lastread = Lastread

            item.Watch = Watch

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
