Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for PlayersInTeams
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class PlayersInTeamController

        ' Preload our schema..
        Dim thisSchemaLoad As PlayersInTeam = New PlayersInTeam()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As PlayersInTeamCollection

            Dim coll As PlayersInTeamCollection = New PlayersInTeamCollection()
            Dim qry As Query = New Query(PlayersInTeam.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Id As Object) As PlayersInTeamCollection

            Dim coll As PlayersInTeamCollection = New PlayersInTeamCollection().Where("ID", Id).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As PlayersInTeamCollection

            Dim coll As PlayersInTeamCollection = New PlayersInTeamCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Id As Object) As Boolean

            Return (PlayersInTeam.Delete(Id) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Id As Object) As Boolean

            Return (PlayersInTeam.Destroy(Id) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal PlayerID As Integer, ByVal TeamID As Integer)

            Dim item As PlayersInTeam = New PlayersInTeam()

            item.PlayerID = PlayerID

            item.TeamID = TeamID


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Id As Integer, ByVal PlayerID As Integer, ByVal TeamID As Integer)

            Dim item As PlayersInTeam = New PlayersInTeam()

            item.Id = Id

            item.PlayerID = PlayerID

            item.TeamID = TeamID

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
