Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for PollAnswers
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class PollAnswerController

        ' Preload our schema..
        Dim thisSchemaLoad As PollAnswer = New PollAnswer()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As PollAnswerCollection

            Dim coll As PollAnswerCollection = New PollAnswerCollection()
            Dim qry As Query = New Query(PollAnswer.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal PollAnswerId As Object) As PollAnswerCollection

            Dim coll As PollAnswerCollection = New PollAnswerCollection().Where("PollAnswerId", PollAnswerId).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As PollAnswerCollection

            Dim coll As PollAnswerCollection = New PollAnswerCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal PollAnswerId As Object) As Boolean

            Return (PollAnswer.Delete(PollAnswerId) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal PollAnswerId As Object) As Boolean

            Return (PollAnswer.Destroy(PollAnswerId) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal PollAnswerId As Guid, ByVal QuestionId As Guid, ByVal Answer As String, ByVal Rank As Nullable(Of Integer))

            Dim item As PollAnswer = New PollAnswer()

            item.PollAnswerId = PollAnswerId

            item.QuestionId = QuestionId

            item.Answer = Answer

            item.Rank = Rank


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal PollAnswerId As Guid, ByVal QuestionId As Guid, ByVal Answer As String, ByVal Rank As Nullable(Of Integer))

            Dim item As PollAnswer = New PollAnswer()

            item.PollAnswerId = PollAnswerId

            item.QuestionId = QuestionId

            item.Answer = Answer

            item.Rank = Rank

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
