Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for PollQuestions
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class PollQuestionController

        ' Preload our schema..
        Dim thisSchemaLoad As PollQuestion = New PollQuestion()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As PollQuestionCollection

            Dim coll As PollQuestionCollection = New PollQuestionCollection()
            Dim qry As Query = New Query(PollQuestion.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal PollId As Object) As PollQuestionCollection

            Dim coll As PollQuestionCollection = New PollQuestionCollection().Where("PollId", PollId).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As PollQuestionCollection

            Dim coll As PollQuestionCollection = New PollQuestionCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal PollId As Object) As Boolean

            Return (PollQuestion.Delete(PollId) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal PollId As Object) As Boolean

            Return (PollQuestion.Destroy(PollId) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal PollId As Guid, ByVal Question As String, ByVal CreationDate As DateTime, ByVal Memberid As Nullable(Of Guid))

            Dim item As PollQuestion = New PollQuestion()

            item.PollId = PollId

            item.Question = Question

            item.CreationDate = CreationDate

            item.Memberid = Memberid


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal PollId As Guid, ByVal Question As String, ByVal CreationDate As DateTime, ByVal Memberid As Nullable(Of Guid))

            Dim item As PollQuestion = New PollQuestion()

            item.PollId = PollId

            item.Question = Question

            item.CreationDate = CreationDate

            item.Memberid = Memberid

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
