Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for PollReactions
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class PollReactionsController

        ' Preload our schema..
        Dim thisSchemaLoad As PollReactions = New PollReactions()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As PollReactionsCollection

            Dim coll As PollReactionsCollection = New PollReactionsCollection()
            Dim qry As Query = New Query(PollReactions.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal ReactionId As Object) As PollReactionsCollection

            Dim coll As PollReactionsCollection = New PollReactionsCollection().Where("ReactionId", ReactionId).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As PollReactionsCollection

            Dim coll As PollReactionsCollection = New PollReactionsCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal ReactionId As Object) As Boolean

            Return (PollReactions.Delete(ReactionId) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal ReactionId As Object) As Boolean

            Return (PollReactions.Destroy(ReactionId) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal ReactionId As Guid, ByVal UserId As Guid, ByVal CreationDate As DateTime, ByVal Reaction As String, ByVal PollId As Guid)

            Dim item As PollReactions = New PollReactions()

            item.ReactionId = ReactionId

            item.UserId = UserId

            item.CreationDate = CreationDate

            item.Reaction = Reaction

            item.PollId = PollId


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal ReactionId As Guid, ByVal UserId As Guid, ByVal CreationDate As DateTime, ByVal Reaction As String, ByVal PollId As Guid)

            Dim item As PollReactions = New PollReactions()

            item.ReactionId = ReactionId

            item.UserId = UserId

            item.CreationDate = CreationDate

            item.Reaction = Reaction

            item.PollId = PollId

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
