Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for PollVotes
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class PollVoteController

        ' Preload our schema..
        Dim thisSchemaLoad As PollVote = New PollVote()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As PollVoteCollection

            Dim coll As PollVoteCollection = New PollVoteCollection()
            Dim qry As Query = New Query(PollVote.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal VoteId As Object) As PollVoteCollection

            Dim coll As PollVoteCollection = New PollVoteCollection().Where("VoteId", VoteId).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As PollVoteCollection

            Dim coll As PollVoteCollection = New PollVoteCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal VoteId As Object) As Boolean

            Return (PollVote.Delete(VoteId) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal VoteId As Object) As Boolean

            Return (PollVote.Destroy(VoteId) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal VoteId As Guid, ByVal UserId As Guid, ByVal PollAnswerId As Guid, ByVal CreationDate As DateTime, ByVal PollId As Guid)

            Dim item As PollVote = New PollVote()

            item.VoteId = VoteId

            item.UserId = UserId

            item.PollAnswerId = PollAnswerId

            item.CreationDate = CreationDate

            item.PollId = PollId


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal VoteId As Guid, ByVal UserId As Guid, ByVal PollAnswerId As Guid, ByVal CreationDate As DateTime, ByVal PollId As Guid)

            Dim item As PollVote = New PollVote()

            item.VoteId = VoteId

            item.UserId = UserId

            item.PollAnswerId = PollAnswerId

            item.CreationDate = CreationDate

            item.PollId = PollId

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
