Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for Seasons
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class SeasonController

        ' Preload our schema..
        Dim thisSchemaLoad As Season = New Season()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As SeasonCollection

            Dim coll As SeasonCollection = New SeasonCollection()
            Dim qry As Query = New Query(Season.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Id As Object) As SeasonCollection

            Dim coll As SeasonCollection = New SeasonCollection().Where("ID", Id).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As SeasonCollection

            Dim coll As SeasonCollection = New SeasonCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Id As Object) As Boolean

            Return (Season.Delete(Id) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Id As Object) As Boolean

            Return (Season.Destroy(Id) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal StartDate As DateTime, ByVal EndDate As DateTime, ByVal SimpleName As String)

            Dim item As Season = New Season()

            item.StartDate = StartDate

            item.EndDate = EndDate

            item.SimpleName = SimpleName


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Id As Integer, ByVal StartDate As DateTime, ByVal EndDate As DateTime, ByVal SimpleName As String)

            Dim item As Season = New Season()

            item.Id = Id

            item.StartDate = StartDate

            item.EndDate = EndDate

            item.SimpleName = SimpleName

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
