Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the SpamFlag class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class SpamFlagCollection
        Inherits ActiveList(Of SpamFlag, SpamFlagCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is an ActiveRecord class which wraps the SpamFlag table.
    ''' </summary>
    <Serializable()> _
    Partial Public Class SpamFlag
        Inherits ActiveRecord(Of SpamFlag)
#Region ".ctors and Default Settings"

        Public Sub New()
            SetSQLProps()
            InitSetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub
        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByKey(keyID)
        End Sub
        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            InitSetDefaults()
            LoadByParam(columnName, columnValue)
        End Sub
        Private Sub InitSetDefaults()
            SetDefaults()
        End Sub

        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region

#Region "Schema and Query Accessor"

        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If BaseSchema Is Nothing Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property
        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("SpamFlag", TableType.Table, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"
                'columns


                Dim colvarId As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarId.ColumnName = "ID"
                colvarId.DataType = DbType.Int32
                colvarId.MaxLength = 0
                colvarId.AutoIncrement = True
                colvarId.IsNullable = False
                colvarId.IsPrimaryKey = True
                colvarId.IsForeignKey = False
                colvarId.IsReadOnly = False


                schema.Columns.Add(colvarId)

                Dim colvarMessageID As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarMessageID.ColumnName = "MessageID"
                colvarMessageID.DataType = DbType.Int32
                colvarMessageID.MaxLength = 0
                colvarMessageID.AutoIncrement = False
                colvarMessageID.IsNullable = False
                colvarMessageID.IsPrimaryKey = False
                colvarMessageID.IsForeignKey = False
                colvarMessageID.IsReadOnly = False


                schema.Columns.Add(colvarMessageID)

                Dim colvarReporterKey As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarReporterKey.ColumnName = "ReporterKey"
                colvarReporterKey.DataType = DbType.Guid
                colvarReporterKey.MaxLength = 0
                colvarReporterKey.AutoIncrement = False
                colvarReporterKey.IsNullable = False
                colvarReporterKey.IsPrimaryKey = False
                colvarReporterKey.IsForeignKey = False
                colvarReporterKey.IsReadOnly = False


                schema.Columns.Add(colvarReporterKey)

                Dim colvarModeratorKey As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarModeratorKey.ColumnName = "ModeratorKey"
                colvarModeratorKey.DataType = DbType.Guid
                colvarModeratorKey.MaxLength = 0
                colvarModeratorKey.AutoIncrement = False
                colvarModeratorKey.IsNullable = False
                colvarModeratorKey.IsPrimaryKey = False
                colvarModeratorKey.IsForeignKey = False
                colvarModeratorKey.IsReadOnly = False


                schema.Columns.Add(colvarModeratorKey)

                Dim colvarReason As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarReason.ColumnName = "Reason"
                colvarReason.DataType = DbType.String
                colvarReason.MaxLength = -1
                colvarReason.AutoIncrement = False
                colvarReason.IsNullable = True
                colvarReason.IsPrimaryKey = False
                colvarReason.IsForeignKey = False
                colvarReason.IsReadOnly = False


                schema.Columns.Add(colvarReason)

                Dim colvarIsResolved As TableSchema.TableColumn = New TableSchema.TableColumn(schema)
                colvarIsResolved.ColumnName = "IsResolved"
                colvarIsResolved.DataType = DbType.Boolean
                colvarIsResolved.MaxLength = 0
                colvarIsResolved.AutoIncrement = False
                colvarIsResolved.IsNullable = False
                colvarIsResolved.IsPrimaryKey = False
                colvarIsResolved.IsForeignKey = False
                colvarIsResolved.IsReadOnly = False


                schema.Columns.Add(colvarIsResolved)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("SpamFlag", schema)
            End If
        End Sub
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function

#End Region

#Region "Props"


        <XmlAttribute("Id")> _
        Public Property Id() As Integer
            Get
                Return GetColumnValue(Of Integer)("ID")
            End Get

            Set(ByVal value As Integer)
                SetColumnValue("ID", Value)
            End Set
        End Property



        <XmlAttribute("MessageID")> _
        Public Property MessageID() As Integer
            Get
                Return GetColumnValue(Of Integer)("MessageID")
            End Get

            Set(ByVal value As Integer)
                SetColumnValue("MessageID", Value)
            End Set
        End Property



        <XmlAttribute("ReporterKey")> _
        Public Property ReporterKey() As Guid
            Get
                Return GetColumnValue(Of Guid)("ReporterKey")
            End Get

            Set(ByVal value As Guid)
                SetColumnValue("ReporterKey", Value)
            End Set
        End Property



        <XmlAttribute("ModeratorKey")> _
        Public Property ModeratorKey() As Guid
            Get
                Return GetColumnValue(Of Guid)("ModeratorKey")
            End Get

            Set(ByVal value As Guid)
                SetColumnValue("ModeratorKey", Value)
            End Set
        End Property



        <XmlAttribute("Reason")> _
        Public Property Reason() As String
            Get
                Return GetColumnValue(Of String)("Reason")
            End Get

            Set(ByVal value As String)
                SetColumnValue("Reason", Value)
            End Set
        End Property



        <XmlAttribute("IsResolved")> _
        Public Property IsResolved() As Boolean
            Get
                Return GetColumnValue(Of Boolean)("IsResolved")
            End Get

            Set(ByVal value As Boolean)
                SetColumnValue("IsResolved", Value)
            End Set
        End Property




#End Region










        'no foreign key tables defined (0)



        'no ManyToMany tables defined (0)


#Region "ObjectDataSource support"

        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Insert(ByVal varMessageID As Integer, ByVal varReporterKey As Guid, ByVal varModeratorKey As Guid, ByVal varReason As String, ByVal varIsResolved As Boolean)
            Dim item As SpamFlag = New SpamFlag()

            item.MessageID = varMessageID

            item.ReporterKey = varReporterKey

            item.ModeratorKey = varModeratorKey

            item.Reason = varReason

            item.IsResolved = varIsResolved

            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        Public Shared Sub Update(ByVal varId As Integer, ByVal varMessageID As Integer, ByVal varReporterKey As Guid, ByVal varModeratorKey As Guid, ByVal varReason As String, ByVal varIsResolved As Boolean)
            Dim item As SpamFlag = New SpamFlag()

            item.Id = varId

            item.MessageID = varMessageID

            item.ReporterKey = varReporterKey

            item.ModeratorKey = varModeratorKey

            item.Reason = varReason

            item.IsResolved = varIsResolved

            item.IsNew = False
            If Not System.Web.HttpContext.Current Is Nothing Then
                item.Save(System.Web.HttpContext.Current.User.Identity.Name)
            Else
                item.Save(System.Threading.Thread.CurrentPrincipal.Identity.Name)
            End If
        End Sub
#End Region
#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared Id As String = "ID"

            Public Shared MessageID As String = "MessageID"

            Public Shared ReporterKey As String = "ReporterKey"

            Public Shared ModeratorKey As String = "ModeratorKey"

            Public Shared Reason As String = "Reason"

            Public Shared IsResolved As String = "IsResolved"

        End Structure
#End Region
    End Class
End Namespace
