Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Controller class for SpamFlag
    ''' </summary>
    <System.ComponentModel.DataObject()> Partial Public Class SpamFlagController

        ' Preload our schema..
        Dim thisSchemaLoad As SpamFlag = New SpamFlag()
        Private strUserName As String = String.Empty
        Protected ReadOnly Property UserName() As String
            Get
                If strUserName.Length = 0 Then

                    If Not System.Web.HttpContext.Current Is Nothing Then
                        strUserName = System.Web.HttpContext.Current.User.Identity.Name
                    Else
                        strUserName = System.Threading.Thread.CurrentPrincipal.Identity.Name
                    End If
                    Return strUserName
                End If
                Return strUserName
            End Get
        End Property
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchAll() As SpamFlagCollection

            Dim coll As SpamFlagCollection = New SpamFlagCollection()
            Dim qry As Query = New Query(SpamFlag.Schema)
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByID(ByVal Id As Object) As SpamFlagCollection

            Dim coll As SpamFlagCollection = New SpamFlagCollection().Where("ID", Id).Load()
            Return coll

        End Function

        <DataObjectMethod(DataObjectMethodType.Select, True)> Public Function FetchByQuery(ByVal qry As SubSonic.Query) As SpamFlagCollection

            Dim coll As SpamFlagCollection = New SpamFlagCollection()
            coll.LoadAndCloseReader(qry.ExecuteReader())
            Return coll

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, True)> Public Function Delete(ByVal Id As Object) As Boolean

            Return (SpamFlag.Delete(Id) = 1)

        End Function
        <DataObjectMethod(DataObjectMethodType.Delete, False)> Public Function Destroy(ByVal Id As Object) As Boolean

            Return (SpamFlag.Destroy(Id) = 1)

        End Function


        ''' <summary>
        ''' Inserts a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Insert, True)> Public Sub Insert(ByVal MessageID As Integer, ByVal ReporterKey As Guid, ByVal ModeratorKey As Guid, ByVal Reason As String, ByVal IsResolved As Boolean)

            Dim item As SpamFlag = New SpamFlag()

            item.MessageID = MessageID

            item.ReporterKey = ReporterKey

            item.ModeratorKey = ModeratorKey

            item.Reason = Reason

            item.IsResolved = IsResolved


            item.Save(UserName)

        End Sub

        ''' <summary>
        ''' Updates a record, can be used with the Object Data Source
        ''' </summary>
        <DataObjectMethod(DataObjectMethodType.Update, True)> Public Sub Update(ByVal Id As Integer, ByVal MessageID As Integer, ByVal ReporterKey As Guid, ByVal ModeratorKey As Guid, ByVal Reason As String, ByVal IsResolved As Boolean)

            Dim item As SpamFlag = New SpamFlag()

            item.Id = Id

            item.MessageID = MessageID

            item.ReporterKey = ReporterKey

            item.ModeratorKey = ModeratorKey

            item.Reason = Reason

            item.IsResolved = IsResolved

            item.MarkOld()
            item.Save(UserName)

        End Sub
    End Class
End Namespace
