Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the VwAspnetApplication class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class VwAspnetApplicationCollection
        Inherits ReadOnlyList(Of VwAspnetApplication, VwAspnetApplicationCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is  Read-only wrapper class for the vw_aspnet_Applications view.
    ''' </summary>
    <Serializable()> _
    Partial Public Class VwAspnetApplication
        Inherits ReadOnlyRecord(Of VwAspnetApplication)

#Region "Default Settings"
        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region
#Region "Schema Accessor"
        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If (BaseSchema Is Nothing) Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property

        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("vw_aspnet_Applications", TableType.View, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"

                'Columns

                Dim colvarApplicationName As New TableSchema.TableColumn(schema)
                colvarApplicationName.ColumnName = "ApplicationName"
                colvarApplicationName.DataType = DbType.String
                colvarApplicationName.MaxLength = 256
                colvarApplicationName.AutoIncrement = False
                colvarApplicationName.IsNullable = False
                colvarApplicationName.IsPrimaryKey = False
                colvarApplicationName.IsForeignKey = False
                colvarApplicationName.IsReadOnly = False

                schema.Columns.Add(colvarApplicationName)

                Dim colvarLoweredApplicationName As New TableSchema.TableColumn(schema)
                colvarLoweredApplicationName.ColumnName = "LoweredApplicationName"
                colvarLoweredApplicationName.DataType = DbType.String
                colvarLoweredApplicationName.MaxLength = 256
                colvarLoweredApplicationName.AutoIncrement = False
                colvarLoweredApplicationName.IsNullable = False
                colvarLoweredApplicationName.IsPrimaryKey = False
                colvarLoweredApplicationName.IsForeignKey = False
                colvarLoweredApplicationName.IsReadOnly = False

                schema.Columns.Add(colvarLoweredApplicationName)

                Dim colvarApplicationId As New TableSchema.TableColumn(schema)
                colvarApplicationId.ColumnName = "ApplicationId"
                colvarApplicationId.DataType = DbType.Guid
                colvarApplicationId.MaxLength = 0
                colvarApplicationId.AutoIncrement = False
                colvarApplicationId.IsNullable = False
                colvarApplicationId.IsPrimaryKey = False
                colvarApplicationId.IsForeignKey = False
                colvarApplicationId.IsReadOnly = False

                schema.Columns.Add(colvarApplicationId)

                Dim colvarDescription As New TableSchema.TableColumn(schema)
                colvarDescription.ColumnName = "Description"
                colvarDescription.DataType = DbType.String
                colvarDescription.MaxLength = 256
                colvarDescription.AutoIncrement = False
                colvarDescription.IsNullable = True
                colvarDescription.IsPrimaryKey = False
                colvarDescription.IsForeignKey = False
                colvarDescription.IsReadOnly = False

                schema.Columns.Add(colvarDescription)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("vw_aspnet_Applications", schema)
            End If
        End Sub
#End Region

#Region "Query Accessor"
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function
#End Region

#Region ".ctors"
        Public Sub New()
            SetSQLProps()
            SetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub

        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            LoadByKey(keyID)
        End Sub

        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            LoadByParam(columnName, columnValue)
        End Sub
#End Region

#Region "Props"

        <XmlAttribute("ApplicationName")> _
        Public Property ApplicationName() As String
            Get
                Return GetColumnValue(Of String)("ApplicationName")
            End Get
            Set(ByVal value As String)
                SetColumnValue("ApplicationName", value)
            End Set
        End Property

        <XmlAttribute("LoweredApplicationName")> _
        Public Property LoweredApplicationName() As String
            Get
                Return GetColumnValue(Of String)("LoweredApplicationName")
            End Get
            Set(ByVal value As String)
                SetColumnValue("LoweredApplicationName", value)
            End Set
        End Property

        <XmlAttribute("ApplicationId")> _
        Public Property ApplicationId() As Guid
            Get
                Return GetColumnValue(Of Guid)("ApplicationId")
            End Get
            Set(ByVal value As Guid)
                SetColumnValue("ApplicationId", value)
            End Set
        End Property

        <XmlAttribute("Description")> _
        Public Property Description() As String
            Get
                Return GetColumnValue(Of String)("Description")
            End Get
            Set(ByVal value As String)
                SetColumnValue("Description", value)
            End Set
        End Property

#End Region

#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared ApplicationName As String = "ApplicationName"

            Public Shared LoweredApplicationName As String = "LoweredApplicationName"

            Public Shared ApplicationId As String = "ApplicationId"

            Public Shared Description As String = "Description"

        End Structure
#End Region
    End Class
End Namespace
