Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the VwAspnetUsersInRoles class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class VwAspnetUsersInRolesCollection
        Inherits ReadOnlyList(Of VwAspnetUsersInRoles, VwAspnetUsersInRolesCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is  Read-only wrapper class for the vw_aspnet_UsersInRoles view.
    ''' </summary>
    <Serializable()> _
    Partial Public Class VwAspnetUsersInRoles
        Inherits ReadOnlyRecord(Of VwAspnetUsersInRoles)

#Region "Default Settings"
        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region
#Region "Schema Accessor"
        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If (BaseSchema Is Nothing) Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property

        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("vw_aspnet_UsersInRoles", TableType.View, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"

                'Columns

                Dim colvarUserId As New TableSchema.TableColumn(schema)
                colvarUserId.ColumnName = "UserId"
                colvarUserId.DataType = DbType.Guid
                colvarUserId.MaxLength = 0
                colvarUserId.AutoIncrement = False
                colvarUserId.IsNullable = False
                colvarUserId.IsPrimaryKey = False
                colvarUserId.IsForeignKey = False
                colvarUserId.IsReadOnly = False

                schema.Columns.Add(colvarUserId)

                Dim colvarRoleId As New TableSchema.TableColumn(schema)
                colvarRoleId.ColumnName = "RoleId"
                colvarRoleId.DataType = DbType.Guid
                colvarRoleId.MaxLength = 0
                colvarRoleId.AutoIncrement = False
                colvarRoleId.IsNullable = False
                colvarRoleId.IsPrimaryKey = False
                colvarRoleId.IsForeignKey = False
                colvarRoleId.IsReadOnly = False

                schema.Columns.Add(colvarRoleId)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("vw_aspnet_UsersInRoles", schema)
            End If
        End Sub
#End Region

#Region "Query Accessor"
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function
#End Region

#Region ".ctors"
        Public Sub New()
            SetSQLProps()
            SetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub

        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            LoadByKey(keyID)
        End Sub

        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            LoadByParam(columnName, columnValue)
        End Sub
#End Region

#Region "Props"

        <XmlAttribute("UserId")> _
        Public Property UserId() As Guid
            Get
                Return GetColumnValue(Of Guid)("UserId")
            End Get
            Set(ByVal value As Guid)
                SetColumnValue("UserId", value)
            End Set
        End Property

        <XmlAttribute("RoleId")> _
        Public Property RoleId() As Guid
            Get
                Return GetColumnValue(Of Guid)("RoleId")
            End Get
            Set(ByVal value As Guid)
                SetColumnValue("RoleId", value)
            End Set
        End Property

#End Region

#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared UserId As String = "UserId"

            Public Shared RoleId As String = "RoleId"

        End Structure
#End Region
    End Class
End Namespace
