Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the VwAspnetWebPartStatePath class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class VwAspnetWebPartStatePathCollection
        Inherits ReadOnlyList(Of VwAspnetWebPartStatePath, VwAspnetWebPartStatePathCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is  Read-only wrapper class for the vw_aspnet_WebPartState_Paths view.
    ''' </summary>
    <Serializable()> _
    Partial Public Class VwAspnetWebPartStatePath
        Inherits ReadOnlyRecord(Of VwAspnetWebPartStatePath)

#Region "Default Settings"
        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region
#Region "Schema Accessor"
        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If (BaseSchema Is Nothing) Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property

        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("vw_aspnet_WebPartState_Paths", TableType.View, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"

                'Columns

                Dim colvarApplicationId As New TableSchema.TableColumn(schema)
                colvarApplicationId.ColumnName = "ApplicationId"
                colvarApplicationId.DataType = DbType.Guid
                colvarApplicationId.MaxLength = 0
                colvarApplicationId.AutoIncrement = False
                colvarApplicationId.IsNullable = False
                colvarApplicationId.IsPrimaryKey = False
                colvarApplicationId.IsForeignKey = False
                colvarApplicationId.IsReadOnly = False

                schema.Columns.Add(colvarApplicationId)

                Dim colvarPathId As New TableSchema.TableColumn(schema)
                colvarPathId.ColumnName = "PathId"
                colvarPathId.DataType = DbType.Guid
                colvarPathId.MaxLength = 0
                colvarPathId.AutoIncrement = False
                colvarPathId.IsNullable = False
                colvarPathId.IsPrimaryKey = False
                colvarPathId.IsForeignKey = False
                colvarPathId.IsReadOnly = False

                schema.Columns.Add(colvarPathId)

                Dim colvarPath As New TableSchema.TableColumn(schema)
                colvarPath.ColumnName = "Path"
                colvarPath.DataType = DbType.String
                colvarPath.MaxLength = 256
                colvarPath.AutoIncrement = False
                colvarPath.IsNullable = False
                colvarPath.IsPrimaryKey = False
                colvarPath.IsForeignKey = False
                colvarPath.IsReadOnly = False

                schema.Columns.Add(colvarPath)

                Dim colvarLoweredPath As New TableSchema.TableColumn(schema)
                colvarLoweredPath.ColumnName = "LoweredPath"
                colvarLoweredPath.DataType = DbType.String
                colvarLoweredPath.MaxLength = 256
                colvarLoweredPath.AutoIncrement = False
                colvarLoweredPath.IsNullable = False
                colvarLoweredPath.IsPrimaryKey = False
                colvarLoweredPath.IsForeignKey = False
                colvarLoweredPath.IsReadOnly = False

                schema.Columns.Add(colvarLoweredPath)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("vw_aspnet_WebPartState_Paths", schema)
            End If
        End Sub
#End Region

#Region "Query Accessor"
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function
#End Region

#Region ".ctors"
        Public Sub New()
            SetSQLProps()
            SetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub

        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            LoadByKey(keyID)
        End Sub

        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            LoadByParam(columnName, columnValue)
        End Sub
#End Region

#Region "Props"

        <XmlAttribute("ApplicationId")> _
        Public Property ApplicationId() As Guid
            Get
                Return GetColumnValue(Of Guid)("ApplicationId")
            End Get
            Set(ByVal value As Guid)
                SetColumnValue("ApplicationId", value)
            End Set
        End Property

        <XmlAttribute("PathId")> _
        Public Property PathId() As Guid
            Get
                Return GetColumnValue(Of Guid)("PathId")
            End Get
            Set(ByVal value As Guid)
                SetColumnValue("PathId", value)
            End Set
        End Property

        <XmlAttribute("Path")> _
        Public Property Path() As String
            Get
                Return GetColumnValue(Of String)("Path")
            End Get
            Set(ByVal value As String)
                SetColumnValue("Path", value)
            End Set
        End Property

        <XmlAttribute("LoweredPath")> _
        Public Property LoweredPath() As String
            Get
                Return GetColumnValue(Of String)("LoweredPath")
            End Get
            Set(ByVal value As String)
                SetColumnValue("LoweredPath", value)
            End Set
        End Property

#End Region

#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared ApplicationId As String = "ApplicationId"

            Public Shared PathId As String = "PathId"

            Public Shared Path As String = "Path"

            Public Shared LoweredPath As String = "LoweredPath"

        End Structure
#End Region
    End Class
End Namespace
