Imports System 
Imports System.Text 
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.Common
Imports System.Collections
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Configuration 
Imports System.Xml 
Imports System.Xml.Serialization
Imports SubSonic 
Imports SubSonic.Utilities
Namespace InfoPool.Data
    ''' <summary>
    ''' Strongly-typed collection for the VwAspnetWebPartStateUser class.
    ''' </summary>
    <Serializable()> _
    Partial Public Class VwAspnetWebPartStateUserCollection
        Inherits ReadOnlyList(Of VwAspnetWebPartStateUser, VwAspnetWebPartStateUserCollection)
        Public Sub New()
        End Sub
    End Class
    ''' <summary>
    ''' This is  Read-only wrapper class for the vw_aspnet_WebPartState_User view.
    ''' </summary>
    <Serializable()> _
    Partial Public Class VwAspnetWebPartStateUser
        Inherits ReadOnlyRecord(Of VwAspnetWebPartStateUser)

#Region "Default Settings"
        Protected Shared Sub SetSQLProps()
            GetTableSchema()
        End Sub
#End Region
#Region "Schema Accessor"
        Public Shared ReadOnly Property Schema() As TableSchema.Table
            Get
                If (BaseSchema Is Nothing) Then
                    SetSQLProps()
                End If
                Return BaseSchema
            End Get
        End Property

        Private Shared Sub GetTableSchema()
            If (Not IsSchemaInitialized) Then
                'Schema declaration
                Dim schema As TableSchema.Table = New TableSchema.Table("vw_aspnet_WebPartState_User", TableType.View, DataService.GetInstance("InfoPoolData"))
                schema.Columns = New TableSchema.TableColumnCollection()
                schema.SchemaName = "dbo"

                'Columns

                Dim colvarPathId As New TableSchema.TableColumn(schema)
                colvarPathId.ColumnName = "PathId"
                colvarPathId.DataType = DbType.Guid
                colvarPathId.MaxLength = 0
                colvarPathId.AutoIncrement = False
                colvarPathId.IsNullable = True
                colvarPathId.IsPrimaryKey = False
                colvarPathId.IsForeignKey = False
                colvarPathId.IsReadOnly = False

                schema.Columns.Add(colvarPathId)

                Dim colvarUserId As New TableSchema.TableColumn(schema)
                colvarUserId.ColumnName = "UserId"
                colvarUserId.DataType = DbType.Guid
                colvarUserId.MaxLength = 0
                colvarUserId.AutoIncrement = False
                colvarUserId.IsNullable = True
                colvarUserId.IsPrimaryKey = False
                colvarUserId.IsForeignKey = False
                colvarUserId.IsReadOnly = False

                schema.Columns.Add(colvarUserId)

                Dim colvarDataSize As New TableSchema.TableColumn(schema)
                colvarDataSize.ColumnName = "DataSize"
                colvarDataSize.DataType = DbType.Int32
                colvarDataSize.MaxLength = 0
                colvarDataSize.AutoIncrement = False
                colvarDataSize.IsNullable = True
                colvarDataSize.IsPrimaryKey = False
                colvarDataSize.IsForeignKey = False
                colvarDataSize.IsReadOnly = False

                schema.Columns.Add(colvarDataSize)

                Dim colvarLastUpdatedDate As New TableSchema.TableColumn(schema)
                colvarLastUpdatedDate.ColumnName = "LastUpdatedDate"
                colvarLastUpdatedDate.DataType = DbType.DateTime
                colvarLastUpdatedDate.MaxLength = 0
                colvarLastUpdatedDate.AutoIncrement = False
                colvarLastUpdatedDate.IsNullable = False
                colvarLastUpdatedDate.IsPrimaryKey = False
                colvarLastUpdatedDate.IsForeignKey = False
                colvarLastUpdatedDate.IsReadOnly = False

                schema.Columns.Add(colvarLastUpdatedDate)

                BaseSchema = schema

                'add this schema to the provider
                'so we can query it later
                DataService.Providers("InfoPoolData").AddSchema("vw_aspnet_WebPartState_User", schema)
            End If
        End Sub
#End Region

#Region "Query Accessor"
        Public Shared Function CreateQuery() As Query
            Return New Query(Schema)
        End Function
#End Region

#Region ".ctors"
        Public Sub New()
            SetSQLProps()
            SetDefaults()
            MarkNew()
        End Sub

        Public Sub New(ByVal useDatabaseDefaults As Boolean)
            SetSQLProps()
            If useDatabaseDefaults = True Then
                ForceDefaults()
            End If
            MarkNew()
        End Sub

        Public Sub New(ByVal keyID As Object)
            SetSQLProps()
            LoadByKey(keyID)
        End Sub

        Public Sub New(ByVal columnName As String, ByVal columnValue As Object)
            SetSQLProps()
            LoadByParam(columnName, columnValue)
        End Sub
#End Region

#Region "Props"

        <XmlAttribute("PathId")> _
        Public Property PathId() As Nullable(Of Guid)
            Get
                Return GetColumnValue(Of Nullable(Of Guid))("PathId")
            End Get
            Set(ByVal value As Nullable(Of Guid))
                SetColumnValue("PathId", value)
            End Set
        End Property

        <XmlAttribute("UserId")> _
        Public Property UserId() As Nullable(Of Guid)
            Get
                Return GetColumnValue(Of Nullable(Of Guid))("UserId")
            End Get
            Set(ByVal value As Nullable(Of Guid))
                SetColumnValue("UserId", value)
            End Set
        End Property

        <XmlAttribute("DataSize")> _
        Public Property DataSize() As Nullable(Of Integer)
            Get
                Return GetColumnValue(Of Nullable(Of Integer))("DataSize")
            End Get
            Set(ByVal value As Nullable(Of Integer))
                SetColumnValue("DataSize", value)
            End Set
        End Property

        <XmlAttribute("LastUpdatedDate")> _
        Public Property LastUpdatedDate() As DateTime
            Get
                Return GetColumnValue(Of DateTime)("LastUpdatedDate")
            End Get
            Set(ByVal value As DateTime)
                SetColumnValue("LastUpdatedDate", value)
            End Set
        End Property

#End Region

#Region "Columns Struct"
        Public Structure Columns
            Dim x As Integer

            Public Shared PathId As String = "PathId"

            Public Shared UserId As String = "UserId"

            Public Shared DataSize As String = "DataSize"

            Public Shared LastUpdatedDate As String = "LastUpdatedDate"

        End Structure
#End Region
    End Class
End Namespace
