<%@ WebHandler Language="VB" Class="DownloadEvent" %>

Imports System.Web
Imports System.Data.SqlClient
Imports SubSonic
Imports InfoPool.Data

Public Class DownloadEvent : Implements IHttpHandler

    Const BUFFERSIZE As Integer = 1024
    
    Public ReadOnly Property IsReusable() As Boolean Implements IHttpHandler.IsReusable
        Get
            Return True
        End Get
    End Property
    
    Public Sub ProcessRequest(ByVal context As HttpContext) Implements IHttpHandler.ProcessRequest
        Dim response As Web.HttpResponse = context.Response
        Dim request As Web.HttpRequest = context.Request
        response.BufferOutput = True
        response.ContentType = "text/calendar"
        response.Cache.SetCacheability(HttpCacheability.NoCache)
        Dim EventID As Integer = CInt(request.QueryString("EventID"))
        
        Dim viewurl As New Uri(context.Request.Url, "Events/view.aspx?Eventid=" & EventID)
        writeCalEntry(EventID, response.Output, viewurl.ToString)
       
        response.End()
    End Sub
 
    Public Sub writeCalEntry(ByVal EventID As Integer, ByVal output As IO.TextWriter, ByVal url As String)
        Dim qry As New Query(Tables.ClubEvent)
        qry.AddWhere(ClubEvent.Columns.ID, EventID)
        qry.QueryType = QueryType.Select
        qry.Top = "1"
        
        Dim dt As New Data.DataTable()
        dt.Load(qry.ExecuteReader())
        
        If dt.Rows.Count > 0 Then
            Dim dr As Data.DataRow = dt.Rows(0)
       
            Dim starttime, endtime As Date
            Dim title, description, location As String
            Dim sb As New Text.StringBuilder()
            Dim o As Object
            
            starttime = CDate(dr("starttime"))
            If Not IsDBNull(dr("endtime")) Then endtime = CDate(dr("endtime")) Else endtime = starttime
            If Not IsDBNull(dr("title")) Then title = CStr(dr("title")) Else title = "An untitled clubsite event"
            
            o = dr("description")
            If Not IsDBNull(o) AndAlso CStr(o) <> "" Then
                sb.AppendLine(CStr(dr("description")))
            End If
            
            sb.AppendLine()
            sb.Append("Event URL: ")
            o = dr("staticURL")
            If Not IsDBNull(o) AndAlso CStr(o) <> "" Then
                sb.AppendLine(CStr(o))
            Else
                sb.AppendLine(url)
            End If
            
            o = dr("LocationName")
            If Not IsDBNull(o) AndAlso CStr(o) <> "" Then
                location = CStr(o)
                sb.AppendLine()
                sb.Append("Event location: ")
                sb.AppendLine(location)
            Else
                location = Nothing
            End If
            
            o = dr("LocationDirections")
            If Not IsDBNull(o) AndAlso CStr(o) <> "" Then
                sb.AppendLine()
                sb.AppendLine("Location directions:")
                sb.AppendLine(CStr(o))
            End If

            
            Dim uc As New Text.UnicodeEncoding()
            description = sb.ToString
                        
            output.WriteLine("BEGIN:VCALENDAR")
            output.WriteLine("VERSION:2.0")
            output.WriteLine("PRODID:" & url)
            output.WriteLine("METHOD:PUBLISH")
            output.WriteLine("BEGIN:VEVENT")
            output.WriteLine("UID:" & Guid.NewGuid().ToString)
            output.WriteLine("DTSTAMP:" & Now.ToUniversalTime.ToString("yyyyMMddTHHmmss") & "Z")
            output.WriteLine("CATEGORIES:APPOINTMENT;PERSONAL")
            output.WriteLine(EncodeProperty("DESCRIPTION;ENCODING=QUOTED-PRINTABLE:", description))
            output.WriteLine("DTEND:" & endtime.ToUniversalTime.ToString("yyyyMMddTHHmmss") & "Z")
            If Not location Is Nothing Then
                output.WriteLine(EncodeProperty("LOCATION;ENCODING=QUOTED-PRINTABLE:", location))
            End If
            output.WriteLine("PRIORITY:0")
            output.WriteLine("DTSTART:" & starttime.ToUniversalTime.ToString("yyyyMMddTHHmmss") & "Z")
            output.WriteLine("STATUS:NEEDS ACTION")
            output.WriteLine(EncodeProperty("SUMMARY;ENCODING=QUOTED-PRINTABLE:", title))
            output.WriteLine("URL:" & url)
            output.WriteLine("END:VEVENT")
            output.WriteLine("END:VCALENDAR")
        End If
    End Sub
           
    Function EncodeProperty(ByVal key As String, ByVal value As String) As String
        Dim sb As New Text.StringBuilder()
        sb.Append(key)
        sb.Append(value)
        sb.Replace(";", "\;", key.Length, sb.Length - key.Length)
        sb.Replace(vbCrLf, "=0D=0A")
        
        Dim offset As Integer = 76
      
        Do While offset < sb.Length
            Dim pos As Integer = sb.ToString(offset - 5, 10).IndexOf("=0D=0A")
            If pos = -1 Then
                sb.Insert(offset - 5 + pos, "=" & vbCrLf)
                offset += 79 - 5 + pos
            Else
                sb.Insert(offset, "=" & vbCrLf)
                offset += 79
            End If
        Loop
        Return sb.ToString
    End Function
    
    Function EncodeProperty64(ByVal key As String, ByVal value As String) As String
        Dim sb As New Text.StringBuilder()
        sb.Append(key)
        Dim uc As New Text.UnicodeEncoding()
        sb.Append(System.Convert.ToBase64String(uc.GetBytes(value), Base64FormattingOptions.None))
    
        Dim offset As Integer = 76
      
        Do While offset < sb.Length
            sb.Insert(offset, vbCrLf)
            offset += 78
        Loop
        Return sb.ToString
    End Function
    
End Class
