Imports InfoPool.Data
Imports InfoPool.Web
Imports SubSonic

Partial Class Statistics_Default
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim SeasonID As Integer = 0
        If Request("SeasonID") Is Nothing Then
            SeasonID = Settings.CurrentSeason
        Else
            SeasonID = Integer.Parse(Request("SeasonID"))
        End If

        Dim season As New Seasons(Seasons.Columns.Id, SeasonID)

        If season.IsLoaded = False Then
            Response.Redirect("~/default.aspx")
        End If

        SeasonName.Text = season.SimpleName
        TimeFrame.Text = season.StartDate.ToShortDateString() & " - " & season.EndDate.ToShortDateString()

        ConfigDropDown(season.SimpleName)

        TeamListDataSource.SelectParameters(0).DefaultValue = season.Id

        ScoreBox.SeasonID = season.Id

        UpcomingDS.SelectParameters(0).DefaultValue = season.Id

        If User.IsInRole("GameRecorder") Then
            IsGameRecorderOrAdmin = True
        Else
            If User.IsInRole("Administrators") Then
                IsGameRecorderOrAdmin = True
            Else
                IsGameRecorderOrAdmin = False
            End If
        End If

        If IsGameRecorderOrAdmin = True Then
            If Request("seasonid") Is Nothing Then
                AddTeam.NavigateURL = "~/statistics/newteam.aspx?seasonid=" & Settings.CurrentSeason
            End If
            AddTeam.NavigateURL = "~/statistics/newteam.aspx?seasonid=" & Request("seasonid")
        End If
    End Sub

    Private Sub ConfigDropDown(ByVal selseasonname As String)
        Dim col As New SeasonsCollection()
        col.LoadAndCloseReader(Seasons.FetchAll())

        Dim season As New Seasons()

        For Each season In col
            Dim li As New ListItem(season.SimpleName, season.Id)
            If season.SimpleName = selseasonname Then
                li.Selected = True
            Else
                li.Selected = False
            End If
            SeasonsDropDown.Items.Add(li)
        Next

    End Sub

    Protected Sub SeasonsDropDown_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles SeasonsDropDown.SelectedIndexChanged
        Dim selvalue As Integer = Integer.Parse(CType(sender, DropDownList).SelectedValue.ToString())
        If selvalue = Settings.CurrentSeason Then
            Response.Redirect("~/statistics/default.aspx")
        Else
            Response.Redirect("~/statistics/default.aspx?seasonid=" & selvalue.ToString())
        End If
    End Sub

    Private m_isallowed As Boolean = False
    Public Property IsGameRecorderOrAdmin() As Boolean
        Get
            Return m_isallowed
        End Get
        Set(ByVal value As Boolean)
            m_isallowed = value
        End Set
    End Property

    Protected Sub MarkAsCurrent_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MarkAsCurrent.Click
        If Request("seasonid") Is Nothing = False Then
            InfoPool.Web.League.MarkSeasonAsCurrent(Request("seasonid"))
        Else
            MsgBox("ERROR")
        End If
        Response.Redirect("~/statistics/default.aspx")
    End Sub
End Class
