Imports SubSonic
Imports InfoPool.Data

Partial Class Statistics_Game
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Request("id") Is Nothing Then
            Response.Redirect("~/statistics/default.aspx")
        End If

        Dim gme As New Games(Games.Columns.Id, Request("id"))
        GameTitle.Text = gme.Teams.Name & " vs. " & gme.TeamsToTeam2id.Name & " (" & gme.Dte.ToShortDateString() & " " & gme.Dte.ToShortTimeString() & ")"
        Score.Text = "<h4>" & gme.Team1score & " - " & gme.Team2score & "</h4>"
        If gme.IsComplete = True Then
            Score.Text += "<h5>FINAL</h5>"
        End If

        If IsDBNull(gme.NewsID) = False AndAlso Not gme.NewsID.Value = 0 Then
            Dim news As New Announcements(Announcements.Columns.Id, gme.NewsID)
            newslink.Text = "New Article - " & news.Title
            newslink.Visible = True
            newslink.NavigateUrl = "~/news/view.aspx?articleid=" & gme.NewsID.ToString()
        Else
            newslink.Visible = False
        End If

        team1name.Text = gme.Teams.Name
        Team1Stats.SelectParameters(0).DefaultValue = gme.Team1id

        team2name.Text = gme.TeamsToTeam2id.Name
        Team2Stats.SelectParameters(0).DefaultValue = gme.Team2id

        IsGameRecorder = User.IsInRole("GameRecorder")

        If IsGameRecorder = True Then
            EditScore.NavigateUrl = "~/statistics/EditScore.aspx?gameid=" & Request("ID").ToString()
        End If
    End Sub

    Private m_isrec As Boolean = False
    Public Property IsGameRecorder() As Boolean
        Get
            Return m_isrec
        End Get
        Set(ByVal value As Boolean)
            m_isrec = value
        End Set
    End Property
End Class
