Imports InfoPool.Web
Imports InfoPool.Data
Imports System.Data

Partial Class Statistics_Player
    Inherits System.Web.UI.Page

    Private _player As Guid

    Public Property PlayerGuid() As Guid
        Get
            If _player = Guid.Empty Then
                _player = CType(ViewState("Playerid"), Guid)
            End If
            Return _player
        End Get
        Set(ByVal value As Guid)
            ViewState("Playerid") = value
        End Set
    End Property

    Protected Sub Page_InitComplete(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.InitComplete
        SeasonsDropDown.SelectedValue = Settings.CurrentSeason()
        ObjectDataSource2.SelectParameters(1).DefaultValue = Settings.CurrentSeason()
        FullStatsDS.SelectParameters(1).DefaultValue = Settings.CurrentSeason()
    End Sub

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            PlayerGuid = New Guid(Request("Playerid"))
        Catch ex As Exception
            Response.Redirect("~/statistics/default.aspx", True)
        End Try

        ShowMembershipInfo()
        CreateCrumb()
    End Sub

    Private Sub ShowMembershipInfo()
        Dim meminfo As New MemberInfo(MemberInfo.Columns.Memberid, PlayerGuid)
        PlayerName.Text = meminfo.Firstname & " " & meminfo.Lastname
        PlayerName2.Text = meminfo.Firstname & " " & meminfo.Lastname

        AvatarImg.ImageUrl = "~/usercontrols/avatarimagefetch.ashx?MemberID=" & PlayerGuid.ToString()

        Dim MemCreationDate As DateTime = Membership.GetUser(PlayerGuid).CreationDate
        MemSince.Text = MemCreationDate.ToString("MMMM yyyy")
    End Sub

    Private Sub CreateCrumb()
        Dim Team As Teams = League.FindTeam(PlayerGuid)

        TeamStats.Text = Team.Name
        TeamStats.NavigateUrl = "~/statistics/team.aspx?teamid=" & Team.Id.ToString()
    End Sub

    Protected Sub SeasonsDropDown_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles SeasonsDropDown.SelectedIndexChanged
        ObjectDataSource2.SelectParameters(1).DefaultValue = Integer.Parse(CType(sender, DropDownList).SelectedValue.ToString())
        FullStatsDS.SelectParameters(1).DefaultValue = Integer.Parse(CType(sender, DropDownList).SelectedValue.ToString())
    End Sub

End Class
