Imports SubSonic
Imports InfoPool.Data
Imports InfoPool.Web

Partial Class Statistics_Team
    Inherits System.Web.UI.Page

    Private m_teamid As Integer = 0

    Private Property TeamID() As Integer
        Get
            If m_teamid = 0 Then
                m_teamid = CType(ViewState("TeamID"), Integer)
            End If

            Return m_teamid
        End Get
        Set(ByVal value As Integer)
            ViewState("TeamID") = value
        End Set
    End Property

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            TeamID = Integer.Parse(Request("teamid").ToString())
        Catch ex As Exception
            Response.Redirect("~/statistics/default.aspx")
        End Try

        Dim Team As New Teams(Teams.Columns.Id, TeamID)

        TeamStats.Text = Team.Name
        ObjectDataSource1.SelectParameters(0).DefaultValue = Team.Name
        ObjectDataSource1.SelectParameters(1).DefaultValue = Team.Id
        PlayerStatsDS.SelectParameters(0).DefaultValue = Team.Id
        ScoreBox.TeamID = TeamID
        TeamNamelbl.Text = Team.Name
        CoachName.Text = Members.FirstAndLastName(Team.LeaderMemId)

        If User.IsInRole("GameRecorder") Then
            IsGameRecorderOrAdmin = True
        Else
            If User.IsInRole("Administrators") Then
                IsGameRecorderOrAdmin = True
            Else
                IsGameRecorderOrAdmin = False
            End If
        End If
    End Sub

    Private m_isallowed As Boolean = False
    Public Property IsGameRecorderOrAdmin() As Boolean
        Get
            Return m_isallowed
        End Get
        Set(ByVal value As Boolean)
            m_isallowed = value
        End Set
    End Property

    Protected Sub SeasonsDropDown_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles SeasonsDropDown.SelectedIndexChanged
        Response.Redirect("~/statistics/team.aspx?teamid=" & Integer.Parse(CType(sender, DropDownList).SelectedValue.ToString()))
    End Sub

    Protected Sub AddPlayer_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AddPlayer.Click
        InfoPool.Web.League.AddPlayerToTeam(MembersDropDown.SelectedValue, Request("teamid"))
        MsgBox("Player has been added. PLEASE do not try to add this person again. Their stats will not show up in the Team page until statistics for the player has been added.", MsgBoxStyle.Information, "InfoPool - Player Added")
        Response.Redirect("~/statistics/team.aspx?teamid=" & Request("teamid"))
    End Sub
End Class
